using System;
using System.Drawing;
using System.Drawing.Design;
using System.Windows.Forms;
using System.Windows.Forms.Design;

using Symcon.LightRidge.BusinessObjects;

namespace Symcon.Lightridge.LRRUI.Controls
{
	/// <summary>
	/// Summary description for EVVTypeEditor.
	/// </summary>
	public class EVVTypeEditor : UITypeEditor
	{
		private LRREVVs _lrrEvvs = LRRModel.ChildModel.EVVs;
		private LRREVVs lrrevvs = new LRREVVs();
		public EVVTypeEditor()
		{
			
		}
		public override UITypeEditorEditStyle GetEditStyle(System.ComponentModel.ITypeDescriptorContext context)
		{
            if (context == null)
            {
                return UITypeEditorEditStyle.DropDown;
            }
			Symcon.Lightridge.LRRUI.PropertyBag pb = context.Instance as Symcon.Lightridge.LRRUI.PropertyBag;
			//			context.PropertyDescriptor.GetType().GetProperty("ObjRef").GetValue(context.Instance,null);
			PropertyTable pt = context.Instance as PropertyTable;
			//			if(pt != null)
			//			{
			//
			//			}
			//			context.PropertyDescriptor.GetChildProperties(context.Instance)
			foreach(PropertySpec ps in pt.Properties)
			{
				if(ps.Name == context.PropertyDescriptor.Name)
				{

					string[] str = ps.ObjectRef.ToString().Split(new char[]{'|'},2);
					string lookupQualifierID = "";
					string propertyID = "";
					string uomTypeID = "";
					if(str.Length == 1)
					{
						propertyID = str[0];
					}
					else if(str.Length >1)
					{
						lookupQualifierID = str[0];
						propertyID = str[1];
					}

					//string propertyId = ps.ObjectRef.ToString().Remove(0,1);
					//MessageBox.Show("Done");
					if(lookupQualifierID.Trim() != "")
					{
						LRRLookUpQualifier lukupQualifier = LRRModel.LookUpQualifiers.getLookUpQualifierForLkupQualifierID(lookupQualifierID);
						uomTypeID = lukupQualifier.UOMTypeID;
					}
					else
					{
						IProperty iProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(propertyID);
						if(iProp == null)
						{
							iProp = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(propertyID);
							LRRPropertyType lrrpropType = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(iProp.GetPropertyType());
							uomTypeID = lrrpropType.UOMTypeID;
						}
						else
						{
							uomTypeID = iProp.GetUOMType();
						}
					}
					
					
					foreach(LRREVV evv in _lrrEvvs)
					{
						if(evv.UOMTypeID == uomTypeID && !lrrevvs.Contains(evv))
							lrrevvs.Add(evv);
					}
				}
			}
			return UITypeEditorEditStyle.DropDown;
		}
		
		public override object EditValue(System.ComponentModel.ITypeDescriptorContext context, IServiceProvider provider, object value)
		{
			IWindowsFormsEditorService frmsvr = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));
			if(frmsvr != null)
			{
				EvvEditorControl evvTypeEditor = new EvvEditorControl(frmsvr);
				ListBox lstbox = evvTypeEditor.ListBox;
				lstbox.DataSource = lrrevvs;
				lstbox.DisplayMember = "EVV";
				lstbox.ValueMember = "ID";
				lstbox.SelectedValue = value;
				frmsvr.DropDownControl(lstbox);
				LRREVV selectedEvv = lstbox.SelectedItem as LRREVV;
				value =  selectedEvv.EVV;
			}
			return base.EditValue(context, provider, value);
		}
	}
}
