using System;
using Syncfusion.Windows.Forms.Diagram;
using System.Drawing;
using System.Runtime.Serialization;
using System.Drawing.Drawing2D;
using System.ComponentModel;


namespace Symcon.Lightridge.LRRUI.Controls.Tools
{
	[Serializable]
	public class SimpleLink : Link
	{
		#region Fields
		//private EndPointDecorator _endPointDecorator  = new EndPointDecorator(EndPointVisuals.ClosedArrow);
		//private EndPointDecorator _startPointDecorator  = new EndPointDecorator(EndPointVisuals.ClosedArrow);
//		private PolyLine _line;
		#endregion

		#region Constructors


		public SimpleLink():base()
		{

		}


		public SimpleLink(PointF[] pts):base(pts)
		{


		}


		public SimpleLink(Link.Shapes shapeType):base(shapeType)
		{

		}


		public SimpleLink(Link.Shapes shapeType, PointF[] pts): base (shapeType,  pts)
		{

		}

		public SimpleLink(IPoints linkPoints):base(linkPoints)
		{

		}

		/// <summary>
		/// Copy constructor.
		/// </summary>
		/// <param name="src">Source object to copy from.</param>
		public SimpleLink(SimpleLink src) : base(src)
		{
		}

		/// <summary>
		/// Serialization constructor for symbols.
		/// </summary>
		/// <param name="info">Serialization state information.</param>
		/// <param name="context">Streaming context information.</param>
		protected SimpleLink(SerializationInfo info, StreamingContext context) : base(info, context)
		{
		}

		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>Copy of the object this method is invoked against.</returns>
		public override object Clone()
		{
			return new SimpleLink(this);
		}

		

		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}

		#endregion

		#region Properties

		protected override void OnMoveVertex(VertexEventArgs evtArgs)
		{
			try
			{
				base.OnMoveVertex (evtArgs);
			}
			catch
			{

			}
		}

		[Category("LineCap"),Editor(typeof(Syncfusion.Windows.Forms.Diagram.EndPointDecoratorEditor),typeof(System.Drawing.Design.UITypeEditor)),TypeConverter(typeof(EndPointDecoratorConverter))]
		public EndPointDecorator EndCap
		{
			get
			{
				return this.EndPoints.LastEndPointDecorator;
			}
			set
			{
				this.EndPoints.LastEndPointDecorator = value;
				if(this.EndPoints.LastEndPointDecorator != null)
				{
					//this.EndPoints.LastEndPointDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
					this.EndPoints.LastEndPointDecorator.FillStyle.Color = this.LineStyle.LineColor;
				}
			}
		}


		[Category("LineCap"), Editor(typeof(Syncfusion.Windows.Forms.Diagram.EndPointDecoratorEditor),typeof(System.Drawing.Design.UITypeEditor)),TypeConverter(typeof(EndPointDecoratorConverter))]
		public EndPointDecorator StartCap
		{
			get
			{
				return this.EndPoints.FirstEndPointDecorator;
			}
			set
			{
				this.EndPoints.FirstEndPointDecorator = value;
				if(this.EndPoints.FirstEndPointDecorator != null)
				{
					//this.EndPoints.LastEndPointDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
					this.EndPoints.FirstEndPointDecorator.FillStyle.Color = this.LineStyle.LineColor;
				}
			}
		}



		

		[Category("LineCap"),TypeConverter(typeof(SizeConverter))]
		public Size EndCapSize
		{
			get
			{
				if(this.EndPoints.LastEndPointDecorator != null)
					return this.EndPoints.LastEndPointDecorator.Size.ToSize();
				else 
					return new Size(0,0);

			}
			set
			{
				this.EndPoints.LastEndPointDecorator.Size = value;
			}
		}


		[Category("LineCap"),DefaultValue(typeof(Size),null),TypeConverter(typeof(SizeConverter))]
		public Size StartCapSize
		{
			get
			{
				if(this.EndPoints.FirstEndPointDecorator != null)
					return this.EndPoints.FirstEndPointDecorator.Size.ToSize();
				else 
					return new Size(0,0);
			}
			set
			{
				this.EndPoints.FirstEndPointDecorator.Size = value;
			}
		}

		[Category("LineCap")]
		public FillStyle StartCapFillStyle
		{
			get
			{
				if(this.EndPoints.FirstEndPointDecorator != null)
					return this.EndPoints.FirstEndPointDecorator.FillStyle;
				else 
					return null;
			}
		}

		[Category("LineCap")]
		public FillStyle EndCapFillStyle
		{
			get
			{
				if(this.EndPoints.LastEndPointDecorator != null)
					return this.EndPoints.LastEndPointDecorator.FillStyle;
				else 
					return null;
			}
		}

		[Category("LineCap")]
		public LineStyle EndCapLineStyle
		{
			get
			{
				if(this.EndPoints.LastEndPointDecorator != null)
					return this.EndPoints.LastEndPointDecorator.LineStyle;
				else 
					return null;
			}
		}


	
		[Category("LineCap")]
		public LineStyle StartCapLineStyle
		{
			get
			{
				if(this.EndPoints.FirstEndPointDecorator != null)
					return this.EndPoints.FirstEndPointDecorator.LineStyle;
				else 
					return null;
			}
		}

		#endregion

		#region Overrides
		protected override void OnPropertyChanged(PropertyEventArgs evtArgs)
		{
			base.OnPropertyChanged (evtArgs);
			if(evtArgs.PropertyName == "LineColor")
			{
				if(this.EndPoints.LastEndPointDecorator != null)
				{
					this.EndPoints.LastEndPointDecorator.LineStyle.LineColor = (Color)evtArgs.NewValue;
					this.EndPoints.LastEndPointDecorator.FillStyle.Color = (Color)evtArgs.NewValue;
				}
				if(this.EndPoints.FirstEndPointDecorator != null)
				{
					this.EndPoints.FirstEndPointDecorator.LineStyle.LineColor = (Color) evtArgs.NewValue;
					this.EndPoints.FirstEndPointDecorator.FillStyle.Color = (Color)evtArgs.NewValue;
				}
			}
			
		}

		#endregion
	}
}
