using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Reflection;
using System.Diagnostics;
using System.Globalization;
using Symcon.Utils.HeaderDispatcher;
using Symcon.Utils.MessageDispatcher;
using PerpetuumSoft.Framework.Model;
using PerpetuumSoft.Instrumentation.Model;
using Syncfusion.Windows.Forms.Diagram;
//using Syncfusion.Windows.Forms.Diagram.Controls;
//using Syncfusion.Windows.Forms.Diagram.Controls;
using Syncfusion.Windows.Forms.Tools;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.BusinessObjects.Utilities;
using System.Collections.Generic;
 


//Copyright	(C)	2004-2005 Symcom Global	Technologies.  All rights reserved.

namespace Symcon.Lightridge.LRRUI.Controls
{
	public class Canvas	: Syncfusion.Windows.Forms.Diagram.Controls.Diagram
	{
		#region	Fields

		private	System.Windows.Forms.ContextMenu				nodeContextMenu;//Context Menu for each	Node Placed	on the Canvas
		private	System.Windows.Forms.MenuItem					copyNode;//Node	ContextMenu	Item to	copy Node
		private	System.Windows.Forms.MenuItem					deleteNode;//Node ContextMenu Item to Delete Node
		private  System.Windows.Forms.MenuItem					resetNode;//Node ContextMenu Item to Reset Node
		private	System.Windows.Forms.MenuItem					nodeSeparator1;//Node Context Menu Seperator 1
		private	System.Windows.Forms.MenuItem					nodeSeparator2;//Node Context Menu Seperator 2
		private	System.Windows.Forms.MenuItem					cutNode;//Node ContextMenu Item	to Cut Node
		private	System.Windows.Forms.MenuItem					bringToFront;//Node	ContextMenu	Item to	Increase Z-index of	node to	topmost
		private	System.Windows.Forms.MenuItem					sendToBack;//Node ContextMenu Item to Increase Z-index of node to Lowest
		private System.Windows.Forms.MenuItem					mapProps;//Node ContextMenu Item to view Node Details
		private	System.Windows.Forms.MenuItem					nodeAttributeDetails;//Node ContextMenu Item to View AttributeDetails
		private	System.Windows.Forms.MenuItem					nodeCustomFormatting;//Node ContextMenu Item to View AttributeDetails

		private	System.Windows.Forms.MenuItem					setValueVisibility;//Sets the visibility of the labels based on selection
		
		private	System.Windows.Forms.MenuItem					labelAttributeDetails;//Node ContextMenu Item to View Trend

        private System.Windows.Forms.MenuItem            lableSelectedAttribute;
	//	private	System.Windows.Forms.MenuItem					aggregateDetails;







		private	System.Windows.Forms.ContextMenu				basicContextMenu;//Context Menu	for	for	the	Canvas
		private	System.Windows.Forms.MenuItem					copyItem;//Canvas Cotext Menu to copy selection/selections
		private	System.Windows.Forms.MenuItem					pasteItem;//Canvas Cotext Menu to paste	copied node/nodes
		private	System.Windows.Forms.MenuItem					deleteItem;//Canvas	Cotext Menu	to delete selected node/nodes
		private	System.Windows.Forms.MenuItem					cutItem;//Canvas Cotext	Menu to	cut	selected node/nodes
		private	System.Windows.Forms.MenuItem					basicSeparator1;//Canvas Context Menu Seperators 1
		private	System.Windows.Forms.MenuItem					undoItem;//Canvas Context Menu to undo one level
		private	System.Windows.Forms.MenuItem					redoItem;//Canvas Context Menu to redo one level
		private	System.Windows.Forms.MenuItem					basicSeparator2;//Canvas Context Menu Seperators 2
		private	System.Windows.Forms.MenuItem					selectAll;//Canvas Context Menu	to Select All Nodes	on the Canvas
		private	System.Windows.Forms.MenuItem					refresh;//Canvas Context Menu	to Refresh the Canvas
		private	System.Windows.Forms.MenuItem					basicSeparator3;//Canvas Context Menu Seperators 3
		private	System.Windows.Forms.MenuItem					attributeDetails;//Canvas ContextMenu Item to View AttributeDetails
		private	System.Windows.Forms.MenuItem					canvasSetLabelsVisibility;//Sets the visibility of the labels based on selection


		private	System.Windows.Forms.ContextMenu				labelContextMenu;//Context Menu for the Label
		private	System.Windows.Forms.MenuItem miItemTempTrusted;
		private	System.Windows.Forms.MenuItem miItemTrustedOverride;
		private	System.Windows.Forms.MenuItem miItemUncertainOverride;
		private	System.Windows.Forms.MenuItem miItemTempTrustedInput;
		private	System.Windows.Forms.MenuItem miItemTrustedInput;
		private	System.Windows.Forms.MenuItem miItemUncertainInput;
		private	System.Windows.Forms.MenuItem miItem;
		private System.Windows.Forms.MenuItem labelNodeSeperator1;
		private System.Windows.Forms.MenuItem labelNodeSeperator2;
		private System.Windows.Forms.MenuItem labelNodeSeperator3;
		private	System.Windows.Forms.MenuItem displayUOM;//Label ContextMenu Item to Display UOM
		private	System.Windows.Forms.MenuItem viewTrend;//Label ContextMenu Item to View Trend
		

		private System.Windows.Forms.MenuItem labelNodeSeperator4;
		private	System.Windows.Forms.MenuItem changeGridDimensions;//Label ContextMenu Item to Change Row Height
        private System.Windows.Forms.MenuItem removeRow;//Label ContextMenu Item to Remove Row 
        private System.Windows.Forms.MenuItem removeColumn;//Label ContextMenu Item to Remove Column
        private System.Windows.Forms.MenuItem reserGridCell;//Label ContextMenu Item to ResetGridBinding
        private System.Windows.Forms.MenuItem customFormatGridCell;
      //  private List<float> _verticalAnchorList = new List<float>();





//		private	System.Windows.Forms.MenuItem					activeMenuItem;//Node	ContextMenu	Item to	Override

		private string											fileName;
		private string											fileID;
		public  string											fileDescription;
		private bool											fullControl = true;
		private bool											formatpainterFlag=false;
		private Syncfusion.Windows.Forms.Diagram.Symbol							insSymbolTool;
		private bool											_isDeleteTrue = false;


		public	event	EventHandler							ShowAttributeDetails;
		public	event	EventHandler							SetLabelsVisibility;
		public	event	EventHandler							MapProperties;
		public	event	EventHandler							SelectDisplayUOM;
		public	event	EventHandler							ChangeGridDimensions;
        public  event   EventHandler                  RemoveRow;
        public  event   EventHandler                  RemoveColumn;
        public  event   EventHandler                  ResetGridCell;
        public  event   EventHandler                            SetCustomFormatGridCell;
		 public event EventHandler								ResetNode;
		public	event	EventHandler							ViewTrend;
		public	event	EventHandler							SetCustomFormat;
        public  event   EventHandler                            SelectedAttributeDetails;
		
		#endregion

		#region	Constructor
		
		///	<summary>
		///	This is	the	constructor	for	custom 
		///	canvas which extends normal Canvas 
		///	with ruler,	Layout ,Context Menus 
		///	and Key Event Handlers
		///	</summary>
		public Canvas()
		{
			//((System.ComponentModel.ISupportInitialize)(this.Model)).BeginInit();
			this.InitializeNodeMenu();
			this.InitializeCanvasMenu();
			this.InitializeCanvasController();
			this.InitializeCanvasModel();
			this.InitializeCanvasView();
			this.InitializeLabelContextMenu();

			insSymbolTool = new InsertSymbolTool("InsertItem");
//			this.Controller.RegisterTool(insSymbolTool);

            //this.ShowModelContextMenu(typeof(MouseEventArgs));
			//this.ActivateConnectors();
		}

		#endregion Constructor
		
		#region	Private	Methods
		private	void InitializeNodeMenu()
		{
			this.nodeContextMenu			=	new		System.Windows.Forms.ContextMenu();
			this.copyNode					=	new		System.Windows.Forms.MenuItem();
			this.deleteNode				=	new		System.Windows.Forms.MenuItem();
			this.resetNode					=	new		System.Windows.Forms.MenuItem();
			this.cutNode					=	new		System.Windows.Forms.MenuItem();
			this.bringToFront				=	new		System.Windows.Forms.MenuItem();
			this.sendToBack				=	new		System.Windows.Forms.MenuItem();
			this.mapProps					=	new		System.Windows.Forms.MenuItem();
			this.nodeSeparator1			=	new		System.Windows.Forms.MenuItem();
			this.nodeSeparator2			=	new		System.Windows.Forms.MenuItem();
			this.nodeAttributeDetails	=	new		System.Windows.Forms.MenuItem();
			this.nodeCustomFormatting	=	new		System.Windows.Forms.MenuItem();
			this.setValueVisibility		=	new		System.Windows.Forms.MenuItem();
			



			
			// 
			// nodeContextMenu
			// 

			this.nodeContextMenu.MenuItems.AddRange(new	System.Windows.Forms.MenuItem[]	{
																							this.copyNode,
																							this.deleteNode,
																							this.bringToFront,
																							this.sendToBack,
																							this.nodeSeparator1,
																							this.nodeSeparator2,
																							this.mapProps,
																							this.nodeAttributeDetails,
																							this.setValueVisibility,
																							this.nodeCustomFormatting,
																							this.resetNode
				
			});
			// 
			// copyNode
			// 
			this.copyNode.Index	= 0;
			this.copyNode.Text = LRRHeaderText.GetHeaderString("SID_COPY"); 
			this.copyNode.Click	+= new System.EventHandler(this.copyNode_Click);
			// 
			// deleteNode
			// 
			this.deleteNode.Index =	1;
			this.deleteNode.Text = LRRHeaderText.GetHeaderString("SID_DELETE"); 
			this.deleteNode.Click += new System.EventHandler(this.deleteNode_Click);
			// 
			// nodeSeparator1
			// 
			this.nodeSeparator1.Index =	2;
			this.nodeSeparator1.Text = "-";
		
			// 
			// BringToFront
			// 

			this.bringToFront.Index	= 3;
			this.bringToFront.Text = LRRHeaderText.GetHeaderString("SID_BRING_FRONT"); 
			this.bringToFront.Click+=new EventHandler(this.bringToFront_Click);

			//
			//SendToBack
			//
			this.sendToBack.Index =	4;
			this.sendToBack.Text = LRRHeaderText.GetHeaderString("SID_SEND_BACK"); 
			this.sendToBack.Click+=new EventHandler(this.sendToBack_Click);

			//
			//
			//
			this.nodeSeparator2.Index =	5;
			this.nodeSeparator2.Text = "-";

			this.mapProps.Index = 6;
			this.mapProps.Text = LRRHeaderText.GetHeaderString("SID_SELECT_DISPLAY_ATTR"); 
			this.mapProps.Click+=new EventHandler(mapProps_Click);


			this.nodeAttributeDetails.Index = 7;
			this.nodeAttributeDetails.Text = LRRHeaderText.GetHeaderString("SID_SHOW_ATTR_DETL"); 
			this.nodeAttributeDetails.Click+=new EventHandler(attributeDetails_Click);

			this.setValueVisibility.Index = 8;
			this.setValueVisibility.Text = LRRHeaderText.GetHeaderString("SID_SHOW_LABELS");
			this.setValueVisibility.Click+=new EventHandler(setValueVisibility_Click);

			this.nodeCustomFormatting.Index = 9;
			this.nodeCustomFormatting.Text = LRRHeaderText.GetHeaderString("SID_CUSTOM_FORMAT"); 
			this.nodeCustomFormatting.Click+=new EventHandler(nodeCustomFormatting_Click);

			 // 
			// resetNode
			// 
			this.resetNode.Index =	10;
			this.resetNode.Text = LRRHeaderText.GetHeaderString("SID_RESET"); 
			this.resetNode.Click += new System.EventHandler(this.resetNode_Click);

            
		}

		private	void InitializeCanvasMenu()
		{
			this.basicContextMenu	=	new		System.Windows.Forms.ContextMenu();
			this.copyItem			=	new		System.Windows.Forms.MenuItem();
			this.cutItem			=	new		System.Windows.Forms.MenuItem();
			this.pasteItem			=	new		System.Windows.Forms.MenuItem();
			this.deleteItem			=	new		System.Windows.Forms.MenuItem();
			this.undoItem			=	new		System.Windows.Forms.MenuItem();
			this.redoItem			=	new		System.Windows.Forms.MenuItem();
			this.basicSeparator1	=	new		System.Windows.Forms.MenuItem();
			this.basicSeparator2	=	new		System.Windows.Forms.MenuItem();
			this.selectAll			=	new		System.Windows.Forms.MenuItem();
			this.refresh			=	new		System.Windows.Forms.MenuItem();
			this.attributeDetails	=	new		System.Windows.Forms.MenuItem();
			this.canvasSetLabelsVisibility = new System.Windows.Forms.MenuItem();
			this.basicSeparator3	=	new		System.Windows.Forms.MenuItem();




			this.basicContextMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							 this.cutItem,
																							 this.copyItem,
																							 this.pasteItem,
																							 this.deleteItem,
																							 this.basicSeparator1,
																							 this.undoItem,
																							 this.redoItem,
																							 this.basicSeparator2,
																							 this.selectAll,
																							 this.refresh,
																							 this.attributeDetails,
																							 this.basicSeparator3,
																							 this.canvasSetLabelsVisibility
																						 });
			//
			//cutItem
			//
			this.cutItem.Index = 0;
			this.cutItem.Text =	LRRHeaderText.GetHeaderString("SID_CUT");
			this.cutItem.Click+=new	EventHandler(this.cutItem_Click);




			// 
			// copyItem
			// 
			this.copyItem.Index	= 1;
			this.copyItem.Text = LRRHeaderText.GetHeaderString("SID_COPY");
			this.copyItem.Click	+= new System.EventHandler(this.copyItem_Click);
			// 
			// pasteItem
			// 
			this.pasteItem.Index = 2;
			this.pasteItem.Text	=LRRHeaderText.GetHeaderString("SID_PASTE"); 
			this.pasteItem.Click +=	new	System.EventHandler(this.pasteItem_Click);
			// 
			// deleteItem
			// 
			this.deleteItem.Index =	3;
			this.deleteItem.Text = LRRHeaderText.GetHeaderString("SID_DELETE");
			this.deleteItem.Click += new System.EventHandler(this.deleteItem_Click);
			// 
			// basicSeparator1
			// 
			this.basicSeparator1.Index = 4;
			this.basicSeparator1.Text =	"-";
			// 
			// undoItem
			// 
			this.undoItem.Index	= 5;
			this.undoItem.Text =LRRHeaderText.GetHeaderString("SID_UNDO"); 
			this.undoItem.Click	+= new System.EventHandler(this.undoItem_Click);
			// 
			// redoItem
			// 
			this.redoItem.Index	= 6;
			this.redoItem.Text = LRRHeaderText.GetHeaderString("SID_REDO");
			this.redoItem.Click	+= new System.EventHandler(this.redoItem_Click);
			// 
			// basicSeparator2
			// 
			this.basicSeparator2.Index = 7;
			this.basicSeparator2.Text =	"-";
			//
			//selectAll
			//
			this.selectAll.Index = 8;
			this.selectAll.Text	= LRRHeaderText.GetHeaderString("SID_SEL_ALL");
			this.selectAll.Click+=new EventHandler(this.selectAll_Click);

			//
			//Refresh
			//
			this.refresh.Index = 9;
			this.refresh.Text	= LRRHeaderText.GetHeaderString("SID_REFRESH");
			this.refresh.Click+=new EventHandler(refresh_Click);

			// 
			// AttributeDetails
			// 
			this.attributeDetails.Index = 11;
			this.attributeDetails.Text = LRRHeaderText.GetHeaderString("SID_SHOW_ATTR_DETL"); 
			this.attributeDetails.Click+=new EventHandler(attributeDetails_Click);


			this.canvasSetLabelsVisibility.Index = 10;
			this.canvasSetLabelsVisibility.Text = LRRHeaderText.GetHeaderString("SID_SHOW_LABELS");
			this.canvasSetLabelsVisibility.Click+=new EventHandler(setValueVisibility_Click);


			// 
			// basicSeparator3
			// 
			this.basicSeparator3.Index = 11;
			this.basicSeparator3.Text =	"-";


		}


		private void InitializeLabelContextMenu()
		{

			this.labelContextMenu = new ContextMenu();

			this.miItem = new MenuItem(LRRHeaderText.GetHeaderString("SID_OVERRIDE_VAL_OFF"),new EventHandler(overRide_Click));
			this.miItem.Index = 0;
			this.labelContextMenu.MenuItems.Add(miItem);

			this.labelNodeSeperator1 = new System.Windows.Forms.MenuItem();
			labelNodeSeperator1.Index =	1;
			labelNodeSeperator1.Text = "-";
			labelContextMenu.MenuItems.Add(labelNodeSeperator1);

			//Uncertain Input Menu
			this.miItemUncertainInput = new MenuItem(LRRHeaderText.GetHeaderString("SID_UNCERTAIN_INPUT"),new EventHandler(overRide_Click));
			this.miItemUncertainInput.Index = 2;
			this.labelContextMenu.MenuItems.Add(miItemUncertainInput);

			//Trusted Input Menu
			this.miItemTrustedInput = new MenuItem(LRRHeaderText.GetHeaderString("SID_TRUSTED_INPUT"),new EventHandler(overRide_Click));
			this.miItemTrustedInput.Index = 3;
			this.labelContextMenu.MenuItems.Add(miItemTrustedInput);

			//TempTrusted Input Menu
			this.miItemTempTrustedInput = new MenuItem(LRRHeaderText.GetHeaderString("SID_TEMP_TRUSTER_INPUT"),new EventHandler(overRide_Click));
			this.miItemTempTrustedInput.Index = 4;
			this.labelContextMenu.MenuItems.Add(miItemTempTrustedInput);

			//Uncertain Override Menu
			this.miItemUncertainOverride = new MenuItem(LRRHeaderText.GetHeaderString("SID_UNCERTAIN_OVERRIDE"),new EventHandler(overRide_Click));
			this.miItemUncertainOverride.Index = 5;//3;
			this.labelContextMenu.MenuItems.Add(miItemUncertainOverride);

			//Trusted Override Menu
			this.miItemTrustedOverride = new MenuItem(LRRHeaderText.GetHeaderString("SID_TRUSTED_OVERRIDE"),new EventHandler(overRide_Click));
			this.miItemTrustedOverride.Index = 6;//4;
			this.labelContextMenu.MenuItems.Add(miItemTrustedOverride);

			//TempTrusted Override Menu
			this.miItemTempTrusted = new MenuItem(LRRHeaderText.GetHeaderString("SID_TEMP_TRUSTER_OVERRIDE"),new EventHandler(overRide_Click));
			this.miItemTempTrusted.Index = 7;//5;
			this.labelContextMenu.MenuItems.Add(miItemTempTrusted);


			this.labelNodeSeperator2 = new System.Windows.Forms.MenuItem();
			labelNodeSeperator2.Index =	8;
			labelNodeSeperator2.Text = "-";
			labelContextMenu.MenuItems.Add(labelNodeSeperator2);


			this.displayUOM			=	new		System.Windows.Forms.MenuItem();
	
			this.displayUOM.Index = 9;
			this.displayUOM.Text = LRRHeaderText.GetHeaderString("SID_SELECTE_DISPLAY_UOM");
			labelContextMenu.MenuItems.Add(displayUOM);
			this.displayUOM.Click+=new EventHandler(displayUOM_Click);

			this.labelNodeSeperator3 = new System.Windows.Forms.MenuItem();
			labelNodeSeperator3.Index =	10;
			labelNodeSeperator3.Text = "-";
			labelContextMenu.MenuItems.Add(labelNodeSeperator3);

			this.viewTrend =			new System.Windows.Forms.MenuItem();
			this.viewTrend.Index = 11;
			this.viewTrend.Text = LRRHeaderText.GetHeaderString("SID_VIEW_TREND");
			labelContextMenu.MenuItems.Add(viewTrend);
			this.viewTrend.Click+=new EventHandler(viewTrend_Click);


			this.labelAttributeDetails =			new System.Windows.Forms.MenuItem();
			this.labelAttributeDetails.Index = 12;
			this.labelAttributeDetails.Text = LRRHeaderText.GetHeaderString("SID_SHOW_ATTR_DETL");
			labelContextMenu.MenuItems.Add(labelAttributeDetails);
			this.labelAttributeDetails.Click+=new EventHandler (attributeDetails_Click);

            this.lableSelectedAttribute =           new System.Windows.Forms.MenuItem();
            this.lableSelectedAttribute.Index = 13;
            this.lableSelectedAttribute.Text = LRRHeaderText.GetHeaderString("SID_SELECT_DISPLAY_ATTR");
            labelContextMenu.MenuItems.Add(lableSelectedAttribute);
            this.lableSelectedAttribute.Click += new EventHandler(selectedAttDetl_Click);
			

			this.labelNodeSeperator4 = new System.Windows.Forms.MenuItem();
			labelNodeSeperator4.Index =	14;
			labelNodeSeperator4.Text = "-";
			labelContextMenu.MenuItems.Add(labelNodeSeperator4);

			this.changeGridDimensions = new System.Windows.Forms.MenuItem();
			this.changeGridDimensions.Index = 15;
			this.changeGridDimensions.Text = LRRHeaderText.GetHeaderString("SID_GRID_DIMENSIONS");
			labelContextMenu.MenuItems.Add(changeGridDimensions);
			this.changeGridDimensions.Click+=new EventHandler(changeGridDimensions_Click);


            this.reserGridCell = new System.Windows.Forms.MenuItem();
            this.reserGridCell.Index = 16;
            this.reserGridCell.Text = "Reset";//LRRHeaderText.GetHeaderString("SID_GRID_DIMENSIONS");
            labelContextMenu.MenuItems.Add(reserGridCell);
            this.reserGridCell.Click += new EventHandler(reserGridCell_Click);

            this.removeRow = new System.Windows.Forms.MenuItem();
            this.removeRow.Index = 17;
            this.removeRow.Text = "Remove Row";//LRRHeaderText.GetHeaderString("SID_GRID_DIMENSIONS");
            labelContextMenu.MenuItems.Add(removeRow);
            this.removeRow.Click += new EventHandler(removeRow_Click);

            this.removeColumn = new System.Windows.Forms.MenuItem();
            this.removeColumn.Index = 18;
            this.removeColumn.Text = "Remove Column";//LRRHeaderText.GetHeaderString("SID_GRID_DIMENSIONS");
            labelContextMenu.MenuItems.Add(removeColumn);
            this.removeColumn.Click += new EventHandler(removeColumn_Click);

            this.customFormatGridCell = new System.Windows.Forms.MenuItem();
            this.customFormatGridCell.Index = 19;
            this.customFormatGridCell.Text = "Custom Format";//LRRHeaderText.GetHeaderString("SID_GRID_DIMENSIONS");
            labelContextMenu.MenuItems.Add(customFormatGridCell);
            this.customFormatGridCell.Click += new EventHandler(customFormatGridCell_Click);
		}

        void removeColumn_Click(object sender, EventArgs e)
        {
            if (RemoveColumn != null)
            {
                RemoveColumn(sender, e);
            }
        }

        void removeRow_Click(object sender, EventArgs e)
        {
            if (RemoveRow != null)
            {
                RemoveRow(sender, e);
            }
        }

        void reserGridCell_Click(object sender, EventArgs e)
        {
            if (ResetGridCell != null)
            {
                ResetGridCell(sender, e);
            }
        }
		
		/// <summary>
		/// reset the symbol 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param> 
		void resetNode_Click(object sender,EventArgs e)
		{
		   if(ResetNode !=null)
		   {
		      ResetNode(sender,e);
		   }
		}

        void customFormatGridCell_Click(object sender, EventArgs e)
        {
            if (SetCustomFormatGridCell != null)
            {
                SetCustomFormatGridCell(sender, e);
            }
        }

		private	void InitializeCanvasController()
		{
			//this.Controller.MaxHistory = 100;
			this.Dock =	System.Windows.Forms.DockStyle.Fill;
			//this.HScroll = true;
			this.LayoutManager = null;
			this.Location =	new	System.Drawing.Point(0,	0);
			//this.Controller.MouseUp+=new MouseEventHandler(this.Controller_MouseUp);
		}



		private	void InitializeCanvasModel()
		{
			// 
			// .Model
			// 
			this.Model.BackgroundStyle.GradientAngle = 90F;
			//this.Model.BackgroundStyle.Properties =	this.Model;
			this.Model.BackgroundStyle.Texture = null;
			this.Model.BackgroundStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			this.Model.BackgroundStyle.Type	= Syncfusion.Windows.Forms.Diagram.BackgroundStyleType.Solid;
			this.Model.BoundaryConstraintsEnabled =	false;
			//this.Model.FillStyle.AlphaFactor = 255;
			//this.Model.FillStyle.GradientAngle = 90F;
			//this.Model.FillStyle.Properties	= this.Model;
			//this.Model.FillStyle.Texture = null;
			//this.Model.FillStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			//this.Model.FillStyle.Type =	Syncfusion.Windows.Forms.Diagram.FillStyleType.Solid;
			//this.Model.Height =	768F;
			this.Model.LineStyle.DashCap = System.Drawing.Drawing2D.DashCap.Flat;
			this.Model.LineStyle.DashOffset	= 0F;
			this.Model.LineStyle.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;
			this.Model.LineStyle.LineJoin =	System.Drawing.Drawing2D.LineJoin.Bevel;
			this.Model.LineStyle.LineWidth = 1F;
			this.Model.LineStyle.MiterLimit	= 10F;
			//this.Model.LineStyle.Properties	= this.Model;
			//this.Model.MeasurementScale	= 1F;
			//this.Model.MeasurementUnits	= System.Drawing.GraphicsUnit.Pixel;
			this.Model.Name	= "Model";
			//this.Model.RenderingStyle.Properties = this.Model;
			this.Model.RenderingStyle.SmoothingMode	= System.Drawing.Drawing2D.SmoothingMode.HighSpeed;
			//this.Model.ShadowStyle.AlphaFactor = 128;
			this.Model.ShadowStyle.OffsetX = 6F;
			this.Model.ShadowStyle.OffsetY = 6F;
			//this.Model.ShadowStyle.Properties =	this.Model;
			this.Model.ShadowStyle.Visible = false;
			//this.Model.Width = 1024F;
			this.Model.LineBridgingEnabled = true;
			this.Model.LineRoutingEnabled = true;
			this.Name =	"";
			this.NudgeIncrement	= 1F;
			this.ScrollGranularity = 1.0F;
			this.Size =	new	System.Drawing.Size(520, 406);
			this.SmartSizeBox =	false;
			this.TabIndex =	0;
			this.Tag = "";
			this.EnableIntelliMouse = true;
		}

		private	void InitializeCanvasView()
		{
			// 
			// .View
			// 
			this.View.Grid.DashOffset =	4F;
			this.View.Grid.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;
			this.View.Grid.GridStyle = Syncfusion.Windows.Forms.Diagram.GridStyle.Line;
			this.View.Grid.HorizontalSpacing = 10F;
			this.View.Grid.SnapToGrid =	false;
			this.View.Grid.VerticalSpacing = 10F;
			this.View.Grid.Visible = true;
			this.View.HandleDisabledColor =	System.Drawing.Color.Black;
			this.View.HandleSize = 6;
			//this.View.HorizontalRuler.Visible =	true;
			this.View.MouseTrackingEnabled = true;
			this.View.PasteOffsetX = 10;
			this.View.PasteOffsetY = 10;
			//this.View.RulerSize	= 15;
			//this.View.RulerUnits = Syncfusion.Windows.Forms.Diagram.MeasurementsUnit.Centimeters;
			//this.View.ShowPageBounds = false;
			//this.View.VerticalRuler.Visible	= true;
			this.VScroll = true;
		}



		public	void ShowLabelContextMenu(MouseEventArgs e,IPropertyValue lrrscpv)
		{
			if(e.Button == MouseButtons.Right && Cursor.Current == Cursors.Default)
			{
				try
				{
					if(lrrscpv.GetType() == typeof(LRRAggregatePropertyValue))
					{
						this.displayUOM.Visible				= true;
						this.miItemTempTrusted.Visible		= true;
                        this.miItemTrustedOverride.Visible = true;
                        this.miItemUncertainOverride.Visible = true;
                        this.miItemTempTrustedInput.Visible = true;
                        this.miItemTrustedInput.Visible = true;
                        this.miItemUncertainInput.Visible = true;
                        this.miItem.Visible = true;
                        this.labelNodeSeperator1.Visible = true;
                        this.labelNodeSeperator2.Visible = true;
                        this.labelAttributeDetails.Visible = true;
                        if (fullControl)
                            this.lableSelectedAttribute.Visible = true;
                        else
                            this.lableSelectedAttribute.Visible = false;
					}
					else if(lrrscpv.GetEditableState())
					{
						this.displayUOM.Visible				= true;
						this.miItemTempTrusted.Visible		= true;
						this.miItemTrustedOverride.Visible	= true;
						this.miItemUncertainOverride.Visible= true;
						this.miItemTempTrustedInput.Visible	= true;
						this.miItemTrustedInput.Visible		= true;
						this.miItemUncertainInput.Visible	= true;
						this.miItem.Visible					= true;
						this.labelNodeSeperator1.Visible	= true;
						this.labelNodeSeperator2.Visible	= true;
                        this.labelAttributeDetails.Visible = true;
                        if (fullControl)
                            this.lableSelectedAttribute.Visible = true;
                        else
                            this.lableSelectedAttribute.Visible = false;
					}
					else
					{
						this.displayUOM.Visible				= true;
						this.miItemTempTrusted.Visible		= false;
						this.miItemTrustedOverride.Visible	= false;
						this.miItemUncertainOverride.Visible= false;
						this.miItemTempTrustedInput.Visible	= false;
						this.miItemTrustedInput.Visible		= false;
						this.miItemUncertainInput.Visible	= false;
						this.miItem.Visible					= false;
						this.labelNodeSeperator1.Visible	= false;
						this.labelNodeSeperator2.Visible	= false;
						this.labelAttributeDetails.Visible = true;
                        //this.lableSelectedAttribute.Visible = true;
                        if (fullControl)
                            this.lableSelectedAttribute.Visible = true;
                        else
                            this.lableSelectedAttribute.Visible = false;
					}
					this.viewTrend.Enabled = lrrscpv.GetIsTrended();
					this.labelContextMenu.Show(this, new	Point(e.X ,	e.Y));				
				}
				catch(Exception	ex)
				{
					Debug.Assert(false,	ex.Message);
				}
			}
		}

		public	void ShowNodeContextMenu(MouseEventArgs	e)
		{
			if(e.Button == MouseButtons.Right && Cursor.Current == Cursors.Default)
			{
				try
				{
					if(fullControl)
					{
						this.deleteNode.Visible	= true;//Temp disabled
						
                        
                        				
						if(this.Controller.CanPaste)
							this.pasteItem.Visible = false;//Temp disabled//true;
						else
							this.pasteItem.Visible = false;
		
		
						if(this.Controller.NodesHit[0] is Link)
						{
							this.copyNode.Visible =	false;
						}
						else
						{
							this.copyNode.Visible =	false;//Temp disabled//true;
						}
						if(this.Controller.NodesHit.First.GetType() == typeof(DynamicGridcontainer))
						{
							this.nodeAttributeDetails.Visible	= false;
							this.nodeCustomFormatting.Visible	= false;
                            //this.reserGridCell.Visible = false;
							this.setValueVisibility.Visible	= true;
							this.mapProps.Visible = false;

						}
						else if(this.SelectionList.Last.GetType().BaseType.Name == "Symbol")
						{
                            this.resetNode.Visible = true;//Temp disabled
                            this.nodeCustomFormatting.Visible = true;
                            this.nodeAttributeDetails.Visible = true;
                            this.setValueVisibility.Visible = true;
                            this.mapProps.Visible = true;

						}
                        else if (this.SelectionList.Last.GetType().BaseType.Name != "Symbol")
                        {
                            this.resetNode.Visible = false;//Temp disabled
                            this.nodeCustomFormatting.Visible = false;
                            this.nodeAttributeDetails.Visible = false;
                            this.setValueVisibility.Visible = false;
                            this.mapProps.Visible = false;
                        }
					}
					else
					{
						this.deleteNode.Visible			= false;
						this.resetNode.Visible			= false;						
						this.pasteItem.Visible			= false;
						this.copyNode.Visible			= false;
						this.cutNode.Visible			= false;
						this.bringToFront.Visible		= false;
						this.sendToBack.Visible			= false;
						this.mapProps.Visible			= false;
						this.nodeSeparator1.Visible		= false;
						this.nodeSeparator2.Visible		= false;
                        this.nodeCustomFormatting.Visible = false;
						if(this.Controller.NodesHit.First.GetType() == typeof(DynamicGridcontainer))
						{
							this.nodeAttributeDetails.Visible	= false;
							//this.nodeCustomFormatting.Visible	= false;
							this.setValueVisibility.Visible	= false;
						}
						else
						{
                            this.resetNode.Visible = false;//Temp disabled
                            this.nodeCustomFormatting.Visible = false;
                            this.nodeAttributeDetails.Visible = false;
                            this.setValueVisibility.Visible = false;
                            this.mapProps.Visible = false;

						}
						
//						if(this.Controller.SelectionList.First.GetType() == typeof(Symcon.Lightridge.LRRUI.Controls.Aggregates))
//						{
//							this.aggregateDetails.Visible = false;
//						}
//						else
//						{
//							this.aggregateDetails.Visible = false;
//						}
					}
						
					this.nodeContextMenu.Show(this,	new	Point(e.X ,	e.Y));				
				}
				catch(Exception	ex)
				{
					Debug.Assert(false,	ex.Message);
				}
			}
		}

		
		// The Model ContextMenu contains menu items that are of a general nature and affect 
		// all nodes that are selected during the event.
		public	void ShowModelContextMenu(MouseEventArgs e)
		{
			if(e.Button == MouseButtons.Right && Cursor.Current == Cursors.Default)
			{
				try
				{
					if(fullControl)
					{
						if(this.Controller.SelectionList.Count != 0)
						{
							this.basicSeparator1.Visible = true;
							deleteItem.Visible = true;
							cutItem.Visible	   = false;////Temp disabled true;
							this.basicSeparator3.Visible = true;
							this.attributeDetails.Visible = true;
							this.canvasSetLabelsVisibility.Visible = true;
						}
						else
						{
							this.basicSeparator1.Visible = false;
							deleteItem.Visible = false;
							cutItem.Visible	= false;
							this.basicSeparator3.Visible = false;
							this.attributeDetails.Visible = false;
							this.canvasSetLabelsVisibility.Visible = false;
						}

						if(this.Controller.CanCopy)
							copyItem.Visible = false;//Temp disabled true;
						else
							copyItem.Visible = false;

						if(this.Controller.CanPaste)
							pasteItem.Visible =	false;//true;//Temp disabled//
						else
							pasteItem.Visible =	false;

						if(this.Controller.UndoCount != 0)
							undoItem.Visible =	true;//true;//Temp disabled//
						else
							undoItem.Visible =	false;

						if(this.Controller.RedoCount != 0)
							redoItem.Visible =	true;//true;//Temp disabled//
						else
							redoItem.Visible =	false;
						if(!redoItem.Visible && !undoItem.Visible)
						{
							basicSeparator2.Visible = false;
						}

						this.basicContextMenu.Show(this	, new Point(e.X	, e.Y));							
					}
					else
					{
						if(this.Controller.SelectionList.Count != 0)
						{
							this.basicSeparator3.Visible = true;
							this.attributeDetails.Visible = true;
							this.canvasSetLabelsVisibility.Visible = false;
						}
						else
						{
							this.basicSeparator3.Visible = false;
							this.attributeDetails.Visible = false;
							this.canvasSetLabelsVisibility.Visible = false;
						}
						deleteItem.Visible = false;
						cutItem.Visible	= false;
						copyItem.Visible = false;//Temp disabled true;
						pasteItem.Visible =	false;//true;//Temp disabled//
						undoItem.Visible = false;
						redoItem.Visible = false;
						selectAll.Visible = true;
						this.basicSeparator1.Visible = false;
						this.basicSeparator2.Visible = false;
						this.basicContextMenu.Show(this	, new Point(e.X	, e.Y));
					}
				}
				catch(Exception	ex)
				{
					Debug.Assert(false,	ex.Message);
				}
			}
		}

		

		private void getControlText(Control ctl)
		{
			if(ctl.Tag != null)
			{
				ctl.Text = LRRHeaderText.GetHeaderString(ctl.Tag.ToString());
			}
			foreach(Control ctlchild in ctl.Controls)
			{
				getControlText(ctlchild);
			}
		}
		#endregion

		#region	Public Methods

		/// <summary>
		/// This Method is called from the form
		/// to zoom the canvas, param zoom is the percentage
		/// of zooming 
		/// </summary>
		/// <param name="zoom"></param>
		public void	Zoom(string	zoom)
		{
			try
			{
				int	idxPctSign = zoom.IndexOf('%');
				if (idxPctSign >= 0)
				{
					zoom = zoom.Remove(idxPctSign, 1);
				}
				int	magVal = System.Convert.ToInt32(zoom,Symcon.BusinessObjects.SymConverter.Culture);
				this.View.Magnification	= new System.Drawing.Size(magVal, magVal);
				this.Refresh();
			}
			catch(Exception	ex)
			{
				Debug.Assert(false,	ex.Message);
			}
		}

		/*public void FormatSymbol(Symbol sourceSymbol, Symbol targetSymbol)
        {
			  if ((sourceSymbol != null) && (targetSymbol != null))
			  {
				  if (targetSymbol.GetType() != typeof(DynamicGridcontainer) && sourceSymbol != targetSymbol && sourceSymbol.GetType() == targetSymbol.GetType())
				  {
					  targetSymbol.FillStyle.AlphaFactor = sourceSymbol.FillStyle.AlphaFactor;
					  targetSymbol.FillStyle.Color = sourceSymbol.FillStyle.Color;
					  targetSymbol.FillStyle.GradientAngle = sourceSymbol.FillStyle.GradientAngle;
					  targetSymbol.FillStyle.GradientBounds = sourceSymbol.FillStyle.GradientBounds;
					  targetSymbol.FillStyle.GradientStartColor = sourceSymbol.FillStyle.GradientStartColor;
					  targetSymbol.FillStyle.Texture = sourceSymbol.FillStyle.Texture;
					  targetSymbol.FillStyle.TextureWrapMode = sourceSymbol.FillStyle.TextureWrapMode;
					  targetSymbol.FillStyle.Type = sourceSymbol.FillStyle.Type;
					  targetSymbol.EditStyle.AllowMove = sourceSymbol.EditStyle.AllowMove;
					  targetSymbol.EditStyle.AllowResize = sourceSymbol.EditStyle.AllowResize;
					  targetSymbol.EditStyle.AllowRotate = sourceSymbol.EditStyle.AllowRotate;
					  targetSymbol.EditStyle.AllowSelect = sourceSymbol.EditStyle.AllowSelect;
					  targetSymbol.EditStyle.AllowVertexEdit = sourceSymbol.EditStyle.AllowVertexEdit;
					  targetSymbol.EditStyle.DefaultHandleEditMode = sourceSymbol.EditStyle.DefaultHandleEditMode;
					  targetSymbol.LineStyle.DashCap = sourceSymbol.LineStyle.DashCap;
					  targetSymbol.LineStyle.DashOffset = sourceSymbol.LineStyle.DashOffset;
					  targetSymbol.LineStyle.DashStyle = sourceSymbol.LineStyle.DashStyle;
					  targetSymbol.LineStyle.EndCap = sourceSymbol.LineStyle.EndCap;
					  targetSymbol.LineStyle.LineColor = sourceSymbol.LineStyle.LineColor;
					  targetSymbol.LineStyle.LineJoin = sourceSymbol.LineStyle.LineJoin;
					  targetSymbol.LineStyle.LineWidth = sourceSymbol.LineStyle.LineWidth;
					  targetSymbol.LineStyle.MiterLimit = sourceSymbol.LineStyle.MiterLimit;
					  //targetSymbol.Width = sourceSymbol.Width;
					  //targetSymbol.Height = sourceSymbol.Height;
					  targetSymbol.Visible = sourceSymbol.Visible;

					  LabelCollection sourceLabel = sourceSymbol.Labels;
					  LabelCollection targetLabel = targetSymbol.Labels;
					  for (int i = 0; i < targetLabel.Count; i++)
					  {
						  targetLabel[i].BackgroundStyle.Color = sourceLabel[i].BackgroundStyle.Color;
						  targetLabel[i].BackgroundStyle.GradientAngle = sourceLabel[i].BackgroundStyle.GradientAngle;
						  targetLabel[i].BackgroundStyle.GradientBounds = sourceLabel[i].BackgroundStyle.GradientBounds;
						  targetLabel[i].BackgroundStyle.GradientStartColor = sourceLabel[i].BackgroundStyle.GradientStartColor;
						  targetLabel[i].BackgroundStyle.Texture = sourceLabel[i].BackgroundStyle.Texture;
						  targetLabel[i].BackgroundStyle.TextureWrapMode = sourceLabel[i].BackgroundStyle.TextureWrapMode;
						  targetLabel[i].BorderStyle.BorderColor = sourceLabel[i].BorderStyle.BorderColor;
						  targetLabel[i].BorderStyle.BorderWidth = sourceLabel[i].BorderStyle.BorderWidth;
						  targetLabel[i].BorderStyle.ShowBorder = sourceLabel[i].BorderStyle.ShowBorder;
						  targetLabel[i].FillStyle.AlphaFactor = sourceLabel[i].FillStyle.AlphaFactor;
						  targetLabel[i].FillStyle.Color = sourceLabel[i].FillStyle.Color;
						  targetLabel[i].FillStyle.GradientAngle = sourceLabel[i].FillStyle.GradientAngle;
						  targetLabel[i].FillStyle.GradientBounds = sourceLabel[i].FillStyle.GradientBounds;
						  targetLabel[i].FillStyle.GradientStartColor = sourceLabel[i].FillStyle.GradientStartColor;
						  targetLabel[i].FillStyle.Texture = sourceLabel[i].FillStyle.Texture;
						  targetLabel[i].FillStyle.TextureWrapMode = sourceLabel[i].FillStyle.TextureWrapMode;
						  targetLabel[i].FillStyle.Type = sourceLabel[i].FillStyle.Type;
						  targetLabel[i].FontStyle.Bold = sourceLabel[i].FontStyle.Bold;
						  targetLabel[i].FontStyle.Family = sourceLabel[i].FontStyle.Family;
						  targetLabel[i].FontStyle.Italic = sourceLabel[i].FontStyle.Italic;
						  targetLabel[i].FontStyle.Name = sourceLabel[i].FontStyle.Name;
						  targetLabel[i].FontStyle.PointSize = sourceLabel[i].FontStyle.PointSize;
						  targetLabel[i].FontStyle.Size = sourceLabel[i].FontStyle.Size;
						  targetLabel[i].FontStyle.Strikeout = sourceLabel[i].FontStyle.Strikeout;
						  targetLabel[i].FontStyle.Style = sourceLabel[i].FontStyle.Style;
						  targetLabel[i].FontStyle.Underline = sourceLabel[i].FontStyle.Underline;
						  targetLabel[i].FontStyle.Unit = sourceLabel[i].FontStyle.Unit;


						  targetLabel[i].DirectionRightToLeft = sourceLabel[i].DirectionRightToLeft;
						  targetLabel[i].DirectionVertical = sourceLabel[i].DirectionVertical;

						  targetLabel[i].Height = sourceLabel[i].Height;
						  targetLabel[i].HorizontalAlignment = sourceLabel[i].HorizontalAlignment;
						  targetLabel[i].MeasureTrailingSpaces = sourceLabel[i].MeasureTrailingSpaces;
						  targetLabel[i].NoClip = sourceLabel[i].NoClip;


						  targetLabel[i].EditStyle.AllowMove = sourceLabel[i].EditStyle.AllowMove;
						  targetLabel[i].EditStyle.AllowResize = sourceLabel[i].EditStyle.AllowResize;
						  targetLabel[i].EditStyle.AllowRotate = sourceLabel[i].EditStyle.AllowRotate;
						  targetLabel[i].EditStyle.AllowSelect = sourceLabel[i].EditStyle.AllowSelect;
						  targetLabel[i].EditStyle.AllowVertexEdit = sourceLabel[i].EditStyle.AllowVertexEdit;
						  targetLabel[i].EditStyle.DefaultHandleEditMode = sourceLabel[i].EditStyle.DefaultHandleEditMode;
						  targetLabel[i].EditStyle.Enabled = sourceLabel[i].EditStyle.Enabled;

						  targetLabel[i].FitBlackBox = sourceLabel[i].FitBlackBox;
						  targetLabel[i].Size = sourceLabel[i].Size;
						  targetLabel[i].VerticalAlignment = sourceLabel[i].VerticalAlignment;
						  targetLabel[i].WrapText = sourceLabel[i].WrapText;
						  targetLabel[i].Width = sourceLabel[i].Width;
						  targetLabel[i].Visible = sourceLabel[i].Visible;
						  LRRLabel lbl = targetLabel[i] as LRRLabel;
						  lbl.Grouped = false;
						  float xSource;
						  float ySource;
						  xSource = sourceLabel[i].X - sourceSymbol.Location.X;
						  ySource = sourceLabel[i].Y - sourceSymbol.Location.Y;
						  xSource = xSource + targetSymbol.X - lbl.X;
						  ySource = ySource + targetSymbol.Y - lbl.Y;
						  lbl.Translate(xSource, ySource);
						  LRRLabel srcLbl = sourceLabel[i] as LRRLabel;
						  lbl.Grouped = srcLbl.Grouped;
					  }

				  }
				  else if (targetSymbol.GetType() == typeof(DynamicGridcontainer) && sourceSymbol != targetSymbol && sourceSymbol.GetType() == targetSymbol.GetType())
				  {

					  DynamicGridcontainer sourceGrid = sourceSymbol as DynamicGridcontainer;
					  DynamicGridcontainer targetGrid = targetSymbol as DynamicGridcontainer;

					  //dimensions
					  targetGrid.Columns = sourceGrid.Columns;
					  targetGrid.Rows = sourceGrid.Rows;
					  targetGrid.RowHeight = sourceGrid.RowHeight;
					  targetGrid.ColumnWidth = sourceGrid.ColumnWidth;
					  targetGrid.Height = sourceGrid.Height;
					  targetGrid.Width = sourceGrid.Width;

					  //font
					  targetGrid.FontFamily = sourceGrid.FontFamily;
					  targetGrid.CellsFontFamily = sourceGrid.CellsFontFamily;
					  targetGrid.FontSize = sourceGrid.FontSize;


					  //formatting 

					  targetGrid.BorderColor = sourceGrid.BorderColor;
					  targetGrid.BorderWidth = sourceGrid.BorderWidth;
					  targetGrid.CellsBackColor = sourceGrid.CellsBackColor;
					  targetGrid.CellsForeColor = sourceGrid.CellsForeColor;
					  targetGrid.GridBorderColor = sourceGrid.GridBorderColor;
					  targetGrid.GridBorderWidth = sourceGrid.GridBorderWidth;

					  //style
					  targetGrid.BackGroundStyle.Color = sourceGrid.BackGroundStyle.Color;
					  targetGrid.BackGroundStyle.GradientAngle = sourceGrid.BackGroundStyle.GradientAngle;
					  targetGrid.BackGroundStyle.GradientBounds = sourceGrid.BackGroundStyle.GradientBounds;
					  targetGrid.BackGroundStyle.GradientStartColor = sourceGrid.BackGroundStyle.GradientStartColor;
					  targetGrid.BackGroundStyle.Texture = sourceGrid.BackGroundStyle.Texture;
					  targetGrid.BackGroundStyle.TextureWrapMode = sourceGrid.BackGroundStyle.TextureWrapMode;
					  targetGrid.BackGroundStyle.Type = sourceGrid.BackGroundStyle.Type;


					  targetGrid.EditStyle.AllowMove = sourceGrid.EditStyle.AllowMove;
					  targetGrid.EditStyle.AllowResize = sourceGrid.EditStyle.AllowResize;
					  targetGrid.EditStyle.AllowRotate = sourceGrid.EditStyle.AllowRotate;
					  targetGrid.EditStyle.AllowSelect = sourceGrid.EditStyle.AllowSelect;
					  targetGrid.EditStyle.AllowVertexEdit = sourceGrid.EditStyle.AllowVertexEdit;
					  targetGrid.EditStyle.DefaultHandleEditMode = sourceGrid.EditStyle.DefaultHandleEditMode;
					  targetGrid.EditStyle.Enabled = sourceGrid.EditStyle.Enabled;

					  targetGrid.FillStyle.AlphaFactor = sourceGrid.FillStyle.AlphaFactor;
					  targetGrid.FillStyle.Color = sourceGrid.FillStyle.Color;
					  targetGrid.FillStyle.GradientAngle = sourceGrid.FillStyle.GradientAngle;
					  targetGrid.FillStyle.GradientBounds = sourceGrid.FillStyle.GradientBounds;
					  targetGrid.FillStyle.GradientStartColor = sourceGrid.FillStyle.GradientStartColor;
					  targetGrid.FillStyle.Texture = sourceGrid.FillStyle.Texture;
					  targetGrid.FillStyle.TextureWrapMode = sourceGrid.FillStyle.TextureWrapMode;
					  targetGrid.FillStyle.Type = sourceGrid.FillStyle.Type;

					  targetGrid.LineStyle.DashCap = sourceGrid.LineStyle.DashCap;
					  targetGrid.LineStyle.DashOffset = sourceGrid.LineStyle.DashOffset;
					  targetGrid.LineStyle.DashStyle = sourceGrid.LineStyle.DashStyle;
					  targetGrid.LineStyle.EndCap = sourceGrid.LineStyle.EndCap;
					  targetGrid.LineStyle.LineColor = sourceGrid.LineStyle.LineColor;
					  targetGrid.LineStyle.LineJoin = sourceGrid.LineStyle.LineJoin;
					  targetGrid.LineStyle.LineWidth = sourceGrid.LineStyle.LineWidth;
					  targetGrid.LineStyle.MiterLimit = sourceGrid.LineStyle.MiterLimit;

					  targetGrid.TextStyle = sourceGrid.TextStyle;

					  //alignment
					  targetGrid.HorizontalAlignment = sourceGrid.HorizontalAlignment;
					  targetGrid.VerticalAlignment = sourceGrid.VerticalAlignment;


					  targetGrid.ShowGridLines = sourceGrid.ShowGridLines;
					  targetGrid.Visible = sourceGrid.Visible;

					  //targetGrid.Labels.Count = sourceGrid.Labels.Count;

					  for (int i = 0; i < sourceGrid.Labels.Count; i++)
					  {

						  if (i == 0)
						  {
							  //header cells
							  GridHeaderCell targetHeaderCell = targetGrid.Labels[i] as GridHeaderCell;
							  GridHeaderCell sourceHeaderCell = sourceGrid.Labels[i] as GridHeaderCell;
							  targetHeaderCell.Anchor = sourceHeaderCell.Anchor;

							  targetHeaderCell.BackgroundStyle.Color = sourceHeaderCell.BackgroundStyle.Color;
							  targetHeaderCell.BackgroundStyle.GradientAngle = sourceHeaderCell.BackgroundStyle.GradientAngle;
							  targetHeaderCell.BackgroundStyle.GradientBounds = sourceHeaderCell.BackgroundStyle.GradientBounds;
							  targetHeaderCell.BackgroundStyle.GradientStartColor = sourceHeaderCell.BackgroundStyle.GradientStartColor;
							  targetHeaderCell.BackgroundStyle.Texture = sourceHeaderCell.BackgroundStyle.Texture;
							  targetHeaderCell.BackgroundStyle.TextureWrapMode = sourceHeaderCell.BackgroundStyle.TextureWrapMode;

							  targetHeaderCell.BorderStyle.ShowBorder = sourceHeaderCell.BorderStyle.ShowBorder;
							  targetHeaderCell.BorderStyle.BorderColor = sourceHeaderCell.BorderStyle.BorderColor;
							  targetHeaderCell.BorderStyle.BorderWidth = sourceHeaderCell.BorderStyle.BorderWidth;
							  targetHeaderCell.BorderStyle.ShowBorder = sourceHeaderCell.BorderStyle.ShowBorder;

							  targetHeaderCell.DirectionRightToLeft = sourceHeaderCell.DirectionRightToLeft;
							  targetHeaderCell.DirectionVertical = sourceHeaderCell.DirectionVertical;

							  targetHeaderCell.EditStyle.AllowMove = sourceHeaderCell.EditStyle.AllowMove;
							  targetHeaderCell.EditStyle.AllowResize = sourceHeaderCell.EditStyle.AllowResize;
							  targetHeaderCell.EditStyle.AllowRotate = sourceHeaderCell.EditStyle.AllowRotate;


							  targetHeaderCell.FillStyle.AlphaFactor = sourceHeaderCell.FillStyle.AlphaFactor;
							  targetHeaderCell.FillStyle.Color = sourceHeaderCell.FillStyle.Color;
							  targetHeaderCell.FillStyle.GradientAngle = sourceHeaderCell.FillStyle.GradientAngle;
							  targetHeaderCell.FillStyle.GradientBounds = sourceHeaderCell.FillStyle.GradientBounds;
							  targetHeaderCell.FillStyle.GradientStartColor = sourceHeaderCell.FillStyle.GradientStartColor;
							  targetHeaderCell.FillStyle.Texture = sourceHeaderCell.FillStyle.Texture;
							  targetHeaderCell.FillStyle.TextureWrapMode = sourceHeaderCell.FillStyle.TextureWrapMode;


							  targetHeaderCell.FitBlackBox = sourceHeaderCell.FitBlackBox;

							  targetHeaderCell.FontStyle.Bold = sourceHeaderCell.FontStyle.Bold;
							  targetHeaderCell.FontStyle.Family = sourceHeaderCell.FontStyle.Family;
							  targetHeaderCell.FontStyle.Italic = sourceHeaderCell.FontStyle.Italic;
							  targetHeaderCell.FontStyle.Name = sourceHeaderCell.FontStyle.Name;
							  targetHeaderCell.FontStyle.PointSize = sourceHeaderCell.FontStyle.PointSize;
							  targetHeaderCell.FontStyle.Size = sourceHeaderCell.FontStyle.Size;
							  targetHeaderCell.FontStyle.Strikeout = sourceHeaderCell.FontStyle.Strikeout;
							  targetHeaderCell.FontStyle.Style = sourceHeaderCell.FontStyle.Style;
							  targetHeaderCell.FontStyle.Underline = sourceHeaderCell.FontStyle.Underline;
							  targetHeaderCell.FontStyle.Unit = sourceHeaderCell.FontStyle.Unit;

							  targetHeaderCell.Height = sourceHeaderCell.Height;
							  targetHeaderCell.HorizontalAlignment = sourceHeaderCell.HorizontalAlignment;
							  targetHeaderCell.LineLimit = sourceHeaderCell.LineLimit;

							  targetHeaderCell.MeasureTrailingSpaces = sourceHeaderCell.MeasureTrailingSpaces;
							  targetHeaderCell.NoClip = sourceHeaderCell.NoClip;
							  targetHeaderCell.ReadOnly = sourceHeaderCell.ReadOnly;
							  targetHeaderCell.Size = sourceHeaderCell.Size;
							  targetHeaderCell.VerticalAlignment = sourceHeaderCell.VerticalAlignment;
							  targetHeaderCell.Visible = sourceHeaderCell.Visible;
							  targetHeaderCell.Width = sourceHeaderCell.Width;
							  targetHeaderCell.WrapText = sourceHeaderCell.WrapText;

						  }
						  else
						  {

							  GridCell targetGridCell = targetGrid.Labels[i] as GridCell;
							  GridCell sourceGridCell = sourceGrid.Labels[i] as GridCell;
							  if (sourceGridCell != null)
							  {
								  targetGridCell.BackgroundStyle.GradientStartColor = sourceGridCell.BackgroundStyle.GradientStartColor;
								  targetGridCell.BackgroundStyle.Color = sourceGridCell.BackgroundStyle.Color;
								  targetGridCell.BackgroundStyle.GradientAngle = sourceGridCell.BackgroundStyle.GradientAngle;
								  targetGridCell.BackgroundStyle.GradientBounds = sourceGridCell.BackgroundStyle.GradientBounds;

								  targetGridCell.BackgroundStyle.Texture = sourceGridCell.BackgroundStyle.Texture;
								  targetGridCell.BackgroundStyle.TextureWrapMode = sourceGridCell.BackgroundStyle.TextureWrapMode;
								  targetGridCell.BackgroundStyle.Type = sourceGridCell.BackgroundStyle.Type;
								  targetGridCell.LabelColorCode = sourceGridCell.LabelColorCode;
								  targetGridCell.BorderStyle.BorderColor = sourceGridCell.BorderStyle.BorderColor;
								  targetGridCell.BorderStyle.BorderWidth = sourceGridCell.BorderStyle.BorderWidth;
								  targetGridCell.BorderStyle.ShowBorder = sourceGridCell.BorderStyle.ShowBorder;

								  targetGridCell.ColSpan = sourceGridCell.ColSpan;
								  targetGridCell.DirectionRightToLeft = sourceGridCell.DirectionRightToLeft;
								  targetGridCell.DirectionVertical = sourceGridCell.DirectionVertical;

								  targetGridCell.FitBlackBox = sourceGridCell.FitBlackBox;
								  targetGridCell.FontFamily = sourceGridCell.FontFamily;
								  targetGridCell.FontSize = sourceGridCell.FontSize;

								  targetGridCell.FontStyle.Bold = sourceGridCell.FontStyle.Bold;
								  targetGridCell.FontStyle.Family = sourceGridCell.FontStyle.Family;
								  targetGridCell.FontStyle.Italic = sourceGridCell.FontStyle.Italic;
								  targetGridCell.FontStyle.Name = sourceGridCell.FontStyle.Name;
								  targetGridCell.FontStyle.PointSize = sourceGridCell.FontStyle.PointSize;
								  targetGridCell.FontStyle.Size = sourceGridCell.FontStyle.Size;
								  targetGridCell.FontStyle.Strikeout = sourceGridCell.FontStyle.Strikeout;
								  targetGridCell.FontStyle.Style = sourceGridCell.FontStyle.Style;
								  targetGridCell.FontStyle.Underline = sourceGridCell.FontStyle.Underline;
								  targetGridCell.FontStyle.Unit = sourceGridCell.FontStyle.Unit;

								  targetGridCell.Height = sourceGridCell.Height;
								  targetGridCell.HorizontalAlignment = sourceGridCell.HorizontalAlignment;
								  //targetGridCell.IsBinded = sourceGridCell.IsBinded;

								  targetGridCell.LineLimit = sourceGridCell.LineLimit;
								  targetGridCell.MeasureTrailingSpaces = sourceGridCell.MeasureTrailingSpaces;
								  targetGridCell.OldColumnSpan = sourceGridCell.OldColumnSpan;
								  targetGridCell.OldRowSpan = sourceGridCell.OldRowSpan;
								  //targetGridCell.ReadOnly = sourceGridCell.ReadOnly;
								  targetGridCell.RowSpan = sourceGridCell.RowSpan;
								  targetGridCell.ShowBorder = sourceGridCell.ShowBorder;
								  targetGridCell.Size = sourceGridCell.Size;
								  targetGridCell.TextStyle = sourceGridCell.TextStyle;

								  targetGridCell.VerticalAlignment = sourceGridCell.VerticalAlignment;
								  targetGridCell.Visible = sourceGridCell.Visible;
								  //targetGridCell.Width = sourceGridCell.Width;
								  targetGridCell.WrapText = sourceGridCell.WrapText;

								  //targetGridCell.FillStyle.AlphaFactor = sourceGridCell.FillStyle.AlphaFactor;
								  targetGridCell.FillStyle.Color = sourceGridCell.FillStyle.Color;
								  targetGridCell.FillStyle.GradientAngle = sourceGridCell.FillStyle.GradientAngle;
								  //targetGridCell.FillStyle.GradientBounds = sourceGridCell.FillStyle.GradientBounds;
								  //targetGridCell.FillStyle.GradientStartColor = sourceGridCell.FillStyle.GradientStartColor;
								  targetGridCell.FillStyle.Texture = sourceGridCell.FillStyle.Texture;
								  targetGridCell.FillStyle.TextureWrapMode = sourceGridCell.FillStyle.TextureWrapMode;
								  targetGridCell.FillStyle.Type = sourceGridCell.FillStyle.Type;

								  targetGridCell.EditStyle.AllowMove = sourceGridCell.EditStyle.AllowMove;
								  targetGridCell.EditStyle.AllowResize = sourceGridCell.EditStyle.AllowResize;
								  targetGridCell.EditStyle.AllowRotate = sourceGridCell.EditStyle.AllowRotate;
								  targetGridCell.EditStyle.AllowSelect = sourceGridCell.EditStyle.AllowSelect;
								  targetGridCell.EditStyle.AllowVertexEdit = sourceGridCell.EditStyle.AllowVertexEdit;
								  targetGridCell.EditStyle.DefaultHandleEditMode = sourceGridCell.EditStyle.DefaultHandleEditMode;
								  targetGridCell.EditStyle.Enabled = sourceGridCell.EditStyle.Enabled;

							  }
						  }

					  }

					  targetGrid.ShowHeader = sourceGrid.ShowHeader;
					  targetGrid.AutoHidePorts = sourceGrid.AutoHidePorts;

				  }
			  }
        }*/
		public void ActivateConnectors()
		{
			//			// Attach link factory to the default link tool
			//			Tool linkTool = this.Controller.GetTool("LinkTool");
			//			if (linkTool != null && linkTool.GetType() == typeof(LinkTool))
			//			{
			//				((LinkTool)linkTool).LinkFactory = new LinkFactory(this.CreateLink);
			//			}
			//
			//			// Create and register a tool for orthogonal links
			//			LinkTool orthogonalLinkTool = new LinkTool("OrthogonalLinkTool");
			//			orthogonalLinkTool.LinkFactory = new LinkFactory(this.CreateOrthogonalLink);
			//			this.Controller.RegisterTool(orthogonalLinkTool);
			//
			//			// Create and register a tool for directed links
			//			LinkTool directedLinkTool = new LinkTool("DirectedLinkTool");
			//			directedLinkTool.LinkFactory = new LinkFactory(this.CreateDirectedLink);
			//			this.Controller.RegisterTool(directedLinkTool);
			//
			//			// Create and register a tool for arc links
			//			LinkTool arcLinkTool = new LinkTool("ArcLinkTool");
			//			arcLinkTool.LinkFactory = new LinkFactory(this.CreateArcLink);
			//			this.Controller.RegisterTool(arcLinkTool);
			//
			//			// Set focus to the diagram control
			//			this.Focus();
		}

		

		#endregion

		#region	Overrides

		protected override bool	ProcessCmdKey(ref Message msg, Keys	keyData)
		{
			if(fullControl)
			{
				try
				{
					switch(keyData)
					{
						case Keys.Delete: 
						{
							if(this.CanCut)
							{
								DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
								if(_dlgResult == DialogResult.Yes)
								{
									_isDeleteTrue = true;
								}
								else
								{
									_isDeleteTrue = false;
								}
								if(_isDeleteTrue)
								{
									this.Controller.Delete();
								}
							}
							break;
						}
						case Keys.Control |	Keys.X:
						{
//Temp disabled
//							if(this.CanCut)
//								this.Controller.Cut();
							break;
						}
//						case Keys.Control |	Keys.A:
//						{
//							this.Controller.SelectAll();
//							break;
//						}
						case Keys.Control |	Keys.C:
						{
							//Temp disabled
                            if (this.CanCopy)
                                this.Controller.Copy();
							break;
						}
						case Keys.Control |	Keys.V:
						{
//Temp disabled
                            if (this != null)
                            {
                                if (this.CanPaste)
                                    this.Controller.Paste();
                            }
							break;
						}
						case Keys.Control |	Keys.Z:
						{
							if(this.CanUndo)
								this.Controller.UndoCommand();
							break;
						}
						case Keys.Control |	Keys.Y:
						{
							if(this.CanRedo)
								this.Controller.RedoCommand();
							break;
						}
						case Keys.Left:
						{
							this.NudgeLeft();
							break;
						}
						case Keys.Up:
						{
							this.NudgeUp();
							break;
						}
						case Keys.Right:
						{
							this.NudgeRight();
							break;
						}
						case Keys.Down:
						{
							this.NudgeDown();
							break;
						}
                        
                        default:
                            break;
					}
				}
			

				catch(Exception	ex)
				{
					Debug.Assert(false,	ex.Message);
				}
			}
			if(keyData	==(Keys.Control | Keys.A))
			{
				if(fullControl)
				{
					this.Controller.SelectAll();
				}
				else
				{
					foreach(INode node in this.Model.Nodes)
					{
                        if (!this.SelectionList.Contains(node))
                        {
                            this.SelectionList.Add(node);
                        }
					
					}
					this.Model.UpdateViews();
				}
                
			}
            switch (keyData)
            {
                case Keys.Shift | Keys.Up:
                    {
                        this.VerticalAnchorList.Sort();
                        float scrollPosition = -1;
                        foreach (float var in this.VerticalAnchorList)
                        {
                            if (this.View.Origin.Y > var * ((float)this.View.Magnification.Height / 100) + 10)
                            {
                                scrollPosition = var;
                            }
                        }
                        if (scrollPosition != -1)
                        {
                            float yPosition = scrollPosition * ((float)this.View.Magnification.Height / 100);
                            this.View.Origin = new PointF(this.View.Origin.X, yPosition);
                            this.Model.UpdateViews();
                        }
                        break;
                    }
                case Keys.Shift | Keys.Down:
                    {
                        this.VerticalAnchorList.Sort();
                        this.VerticalAnchorList.Reverse();
                        float scrollPosition = -1;
                        foreach (float var in this.VerticalAnchorList)
                        {
                            if (this.View.Origin.Y < var * ((float)this.View.Magnification.Height / 100) - 10)
                            {
                                scrollPosition = var;
                            }
                        }
                        if (scrollPosition != -1)
                        {
                            float yPosition = scrollPosition * ((float)this.View.Magnification.Height / 100);
                            this.View.Origin = new PointF(this.View.Origin.X, yPosition);
                            this.Model.UpdateViews();
                        }
                        break;
                    }
                case Keys.Shift | Keys.Left:
                    {
                        this.HorizontalAnchorList.Sort();
                        float scrollPosition = -1;
                        foreach (float var in this.HorizontalAnchorList)
                        {
                            if (this.View.Origin.X > var * ((float)this.View.Magnification.Width / 100) + 10)
                            {
                                scrollPosition = var;
                            }
                        }
                        if (scrollPosition != -1)
                        {
                            float xPosition = scrollPosition * ((float)this.View.Magnification.Width / 100);
                            this.View.Origin = new PointF(xPosition, this.View.Origin.Y);
                            this.Model.UpdateViews();
                        }
                        break;
                    }
                case Keys.Shift | Keys.Right:
                    {
                        this.HorizontalAnchorList.Sort();
                        this.HorizontalAnchorList.Reverse();
                        float scrollPosition = -1;
                        foreach (float var in this.HorizontalAnchorList)
                        {
                            if (this.View.Origin.X < var * ((float)this.View.Magnification.Width / 100) - 10)
                            {
                                scrollPosition = var;
                            }
                        }
                        if (scrollPosition != -1)
                        {
                            float xPosition = scrollPosition * ((float)this.View.Magnification.Width / 100);
                            this.View.Origin = new PointF(xPosition, this.View.Origin.Y);
                            this.Model.UpdateViews();
                        }
                        break;
                    }
                default:
                    break;
            }
			return base.ProcessCmdKey (ref msg,	keyData);
		}


        /*protected override void OnModelBoundsChanged(object sender, Syncfusion.Windows.Forms.Diagram.BoundsInfo evtArgs)
		{
			try
			{
				base.OnModelBoundsChanged (sender, evtArgs);
				if(evtArgs.Node.GetType().BaseType == typeof(Symbol))
				{
					Symbol smbl	= evtArgs.Node as Symbol;
					bool aspctRatio = true; 
					if(smbl.GetPropertyValue("LockAspectRatio")	== null)
					{
						if(smbl.GetType() == typeof(SystemProperties))
						{
							aspctRatio = false;
						}
					}
					else
					{
						aspctRatio = (bool)smbl.GetPropertyValue("LockAspectRatio")	 ;
					}
					if(aspctRatio)
					{
						float newHeight	= evtArgs.NewBounds.Height;
						float newWidth = evtArgs.NewBounds.Width;
						float oldHeight	= evtArgs.OldBounds.Height;
						float oldWidth = evtArgs.OldBounds.Width;
						float heightRatio =	(newHeight - oldHeight)/oldHeight;
						float widthRatio  =	(newWidth -	oldWidth)/oldWidth;
				
						if((newWidth - oldWidth) !=	0)
						{
							smbl.Height	= oldHeight	+ (oldHeight * widthRatio);
						}
						else if((newHeight - oldHeight)	!= 0)
						{
							smbl.Width = oldWidth +	(oldWidth *	heightRatio);
						}
					}
				}
			}
			catch
			{
			}
		}*/

	
		protected override void OnMouseMove(MouseEventArgs e)
		{
			try
			{
				base.OnMouseMove (e);
			}
			catch(Exception ex)
			{
			}
		}


		//Canvas Eventhandler
		//MouseUp events Handler
		protected override void OnMouseUp(MouseEventArgs e)
		{
			try
            {
                base.OnMouseUp(e);
                if (/*e.Button == MouseButtons.Left && */this.Controller.NodesHit.First != null && this.Controller.NodesHit.First.GetType() == typeof(Symcon.Lightridge.LRRUI.Controls.DynamicGridcontainer) )
                {
                    if (this.SelectionList.First != null && this.Controller.NodesHit.First != this.SelectionList.First && this.SelectionList.First.GetType() != typeof(DynamicGridcontainer))// && this.SelectionList.First.GetType().BaseType == typeof(Syncfusion.Windows.Forms.Diagram.SymbolLabel))
                    {
                        //Do Nothing
                    }
                    else
                    {
                        if (Control.ModifierKeys != Keys.Control)
                            this.SelectionList.Clear();
                        if (!this.SelectionList.Contains(this.Controller.NodesHit.First))
                        {
                            this.SelectionList.Add(this.Controller.NodesHit.First);
                        }
                    }
                }
                else if (/*e.Button == MouseButtons.Left && */Cursor.Current == Cursors.Arrow)
                {
                    if (this.Controller.NodesHit.Count > 0 && this.Controller.NodesHit.Last.GetType().BaseType != typeof(SymbolLabel))
                    {
                        if (Control.ModifierKeys != Keys.Control)
                            this.SelectionList.Clear();
                        if (!this.SelectionList.Contains(this.Controller.NodesHit.First))
                        {
                            this.SelectionList.Add(this.Controller.NodesHit.First);
                        }

                    }
                }
				if(e.Button == MouseButtons.Right && this.Cursor == Cursors.Arrow)
				{
					HideGridMenuItems();
					if(this.Controller.NodesHit.Count > 0 && this.Controller.NodesHit.Last.GetType() == typeof(LRRLabel))
					{
						LRRLabel lbl =  this.Controller.NodesHit.Last as LRRLabel;
						if(lbl.Tag != null)
						{
							IPropertyValue lrrscpv =  lbl.Tag as  IPropertyValue;
							if(lrrscpv != null)
							{
								ProcessMenuItems(lrrscpv,labelContextMenu);
								this.ShowLabelContextMenu(e,lrrscpv);
							}
						}
					}
						//For Grid Cell: need to add later
					else if(this.Controller.NodesHit.Count > 0 && this.Controller.NodesHit.Last.GetType() == typeof(GridCell))
					{
						GridCell lbl =  this.Controller.NodesHit.Last as GridCell;
						if(lbl.IsBinded)
						{
							IPropertyValue lrrscpv =  lbl.Tag as  IPropertyValue;
							if(lrrscpv != null)
							{
								ProcessMenuItems(lrrscpv,labelContextMenu);
								ShowGridMenuItems();
								this.labelNodeSeperator4.Visible	= true;
								this.ShowLabelContextMenu(e,lrrscpv);
							}
						}
						else
						{
							ShowGridMenuItems();
							//labelNodeSeperator4.Visible = false;
							this.labelContextMenu.Show(this, new	Point(e.X ,	e.Y));				
						}
					}
					else if(this.Controller.NodesHit.Count > 0/*this.SelectionList.Count >	0 */&& this.Controller.NodesHit.Last.GetType() != typeof(Symbol))
					{
						this.SelectionList.Clear();
						this.SelectionList.Add(this.Controller.NodesHit.First);
						this.Model.UpdateViews();
						this.ShowNodeContextMenu(e);
					}
					else 
						this.ShowModelContextMenu(e);			
				}
				

				
			}
			catch(Exception ex)
			{

			}
		}

		private void ShowGridMenuItems()
		{
			foreach(MenuItem currentMItem in  labelContextMenu.MenuItems)
			{
				currentMItem.Visible = false;
			}
            if (fullControl)
            {
                changeGridDimensions.Visible = true;    
            }
            else
            {
                changeGridDimensions.Visible = false;    
            }
            DynamicGridcontainer dgc = base.SelectionList.First as DynamicGridcontainer;
            if (dgc != null)
            {
                if (dgc.SelectedCell.IsBinded && fullControl)
                {
                    reserGridCell.Visible = true;
                    customFormatGridCell.Visible = true;
                }
                else 
                {
                    reserGridCell.Visible = false;
                    customFormatGridCell.Visible = false;
                }
                if (dgc.Columns > 1 && fullControl)
                {
                     removeColumn.Visible = true;
                }
                else 
                {
                    removeColumn.Visible = false;
                }
                if (dgc.Rows > 1 && fullControl)
                {
                    removeRow.Visible = false;
                }
            }
		}

		private void HideGridMenuItems()
		{
			changeGridDimensions.Visible = false;
            removeColumn.Visible = false;
            removeRow.Visible = false;
			labelNodeSeperator4.Visible = false;
            reserGridCell.Visible = false;
            customFormatGridCell.Visible = false;
		}


//		protected override void OnSelectionListChanged(object sender, NodeCollectionEventArgs evtArgs)
//		{
//			base.OnSelectionListChanged (sender, evtArgs);
//			if(this.SelectionList.Count == 0 && evtArgs.Node == null)
//			{
//				foreach(INode node in this.Model.Nodes)
//				{
//					if(node is DynamicGridcontainer)
//					{
//						if(!this.SelectionList.Contains(node) && evtArgs.ChangeType != CollectionExChangeType.Clear)
//						{
//							DynamicGridcontainer dGridContainer = node as DynamicGridcontainer;
//							if(dGridContainer.SelectedCell != null)
//							{
//								dGridContainer.ClearSelection();
//							}
//						}
//					}
//				}
//			}
//		}
//

		#endregion

		#region	Events

		//Cut the Selected Nodes from the Diagram
		private	void cutItem_Click(object sender, EventArgs	e)
		{
			this.Controller.Cut();
			this.Model.UpdateViews();
		}

		// Delete the selected nodes from the diagram
		private	void deleteItem_Click(object sender, EventArgs e)
		{
			this.Controller.Delete();
			this.Model.UpdateViews();
		}

		// Copy	selected nodes to the clipboard
		private	void copyItem_Click(object sender, EventArgs e)
		{
			this.Controller.Copy();
		}
		
		// Paste clipboard contents
		private	void pasteItem_Click(object	sender,	EventArgs e)
		{
			this.Controller.Paste(this.Model.DefaultLayerName, this.Controller.MouseLocation);
		}

		// Undo
		private	void undoItem_Click(object sender, EventArgs e)
		{
			this.Controller.UndoCommand();
		}

		//Redo
		private	void redoItem_Click(object sender, EventArgs e)
		{
			this.Controller.RedoCommand();
		}								

		//Redo
		private	void selectAll_Click(object	sender,	EventArgs e)
		{
			this.Controller.SelectAll();
			if(!fullControl)
			{
				foreach(INode node in this.Model.Nodes)
                {
                    if (!this.SelectionList.Contains(node))
                    {
                        this.SelectionList.Add(node);
                    }
				}
				this.Model.UpdateViews();
			}
		}
		
		//NodeContextMenu Handlers

		// Copy	the	node to	the	clipboard
		private	void copyNode_Click(object sender, System.EventArgs	e)
		{
			this.Controller.Copy();		
		}		

		/// <summary>
		/// Delete the node over	which the mouse	was	right clicked
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private	void deleteNode_Click(object sender, System.EventArgs e)
		{
			if(this.Controller.NodesHit.Count >	0)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isDeleteTrue = true;
				}
				else
				{
					_isDeleteTrue = false;
				}
				if(_isDeleteTrue)
				{
					RemoveNodesCmd removecmd = new RemoveNodesCmd();
					ArrayList nodelist = new ArrayList(this.Controller.NodesHit);
					foreach(INode node in nodelist)
					{
						if((node.Parent	is Model) || (node.Parent is Layer))
							removecmd.Nodes.Add(node);
					}
					this.Controller.ExecuteCommand(removecmd);
					this.Model.UpdateViews();
				}
			}		
		}

		// Bring the node on which the mouse was right clicked to front
		private	void bringToFront_Click(object sender, EventArgs e)
		{
			this.Controller.BringToFront();
		}

		// Bring the node on which the mouse was right clicked backwards
		private	void sendToBack_Click(object sender, EventArgs e)
		{
			this.Controller.SendToBack();
		}

		
		private void refresh_Click(object sender, EventArgs e)
		{
			this.Update();
			this.Refresh();
			this.View.ScrollBy(0,0);
		}

		
		private void overRide_Click(object sender, EventArgs e)
		{
			
		}

		
		private void attributeDetails_Click(object sender, EventArgs e)
		{
			if(ShowAttributeDetails != null)
			{
				ShowAttributeDetails(this.nodeContextMenu,e);
			}
		}

        private void selectedAttDetl_Click(object sender, EventArgs e)
        {
            if (SelectedAttributeDetails != null)
            {
                SelectedAttributeDetails(this.nodeContextMenu, e);
            }
        }
		
		private void displayUOM_Click(object sender, EventArgs e)
		{
			if(SelectDisplayUOM != null)
			{
				SelectDisplayUOM(this,new EventArgs());
			}
		}

		
		private void mapProps_Click(object sender, EventArgs e)
		{
			if(MapProperties != null)
			{
				MapProperties(this,e);
			}
		}

		
		private void viewTrend_Click(object sender, EventArgs e)
		{
			if(ViewTrend != null)
			{
				ViewTrend(this,new EventArgs());
			}
		}


		
		/// <summary>
		/// Sets State of the menu items
		/// </summary>
		/// <param name="iPropValue"></param>
		/// <param name="contMenu"></param>
		private void ProcessMenuItems(IPropertyValue iPropValue,ContextMenu contMenu)
		{

			bool overridedState = iPropValue.GetOverrideState();
			ErrorCode errorCode   = iPropValue.GetErrorCode();
			for(int i=0;i < labelContextMenu.MenuItems.Count;i++)
			{
				MenuItem miItem = labelContextMenu.MenuItems[i];
				miItem.Checked = false;
				miItem.Enabled = true;

				switch(miItem.Index)
				{
						//Override Values Menu
					case 0:
						miItem.Enabled = overridedState;
						break;
						//Uncertain Input Menu
					case 2:
						miItem.Enabled = !overridedState;
						if((errorCode & (ErrorCode.UNCERTAIN)) == (ErrorCode.UNCERTAIN) && !overridedState)
						{
							miItem.Checked = true;
						}
						break;
						//Trusted Input Menu
					case 3:
						miItem.Enabled = !overridedState;
						if((errorCode & (ErrorCode.TRUSTED)) == (ErrorCode.TRUSTED) && !overridedState)
						{
							miItem.Checked = true;
						}
						break;
						//Temp Trusted Input Menu
					case 4:
						miItem.Enabled = !overridedState;
						if((errorCode & (ErrorCode.TEMPTRUSTED)) == (ErrorCode.TEMPTRUSTED) && !overridedState)
						{
							miItem.Checked = true;
						}
						break;
						//Uncertain Override Menu
					case 5://3:
						miItem.Enabled = overridedState;
						if((errorCode & (ErrorCode.UNCERTAIN)) == (ErrorCode.UNCERTAIN) && overridedState)
						{
							miItem.Checked = true;
						}
						break;
						//Trusted Override Menu
					case 6://4:
						miItem.Enabled = overridedState;
						if((errorCode & (ErrorCode.TRUSTED)) == (ErrorCode.TRUSTED) && overridedState)
						{
							miItem.Checked = true;
						}
						break;
						//Temp Trusted Override Menu
					case 7://5:
						miItem.Enabled = overridedState;
						if((errorCode & (ErrorCode.TEMPTRUSTED)) == (ErrorCode.TEMPTRUSTED) && overridedState)
						{
							miItem.Checked = true;
						}
						break;
					default:
						break;
				}
			}
		}
		
		#endregion 

		#region	Public Properties

		/// <summary>
		/// File Id Associated with the Canvas
		/// </summary>
		[Browsable(false)]
		public string FileID
		{
			get{return fileID;}
			set
			{
				fileID = value;}
		}

		/// <summary>
		/// FileName associated with the canvas
		/// </summary>
		[Browsable(false)]
		public string FileName
		{
			get{return  fileName;}
			set
			{
				
				fileName = value;
				this.FileID = Guid.NewGuid().ToString();

			}
		}

		[Browsable(false)]
		public string FileDescription
		{
			get
			{
				return fileDescription;
			}
			set
			{
				fileDescription = value;
			}
		}

		[Browsable(false)]
		public bool HasFileName
		{
			get
			{
				return FileName != null && FileName.Length >0;
			}
				
		}


		[Browsable(false)]
		public bool FullControl
		{
			get
			{
				return fullControl;
			}
			set
			{
				fullControl = value;
			}
				
		}
		
		
		[Browsable(false)]
		public bool FormatpainterFlag
		{
			get
			{
				return formatpainterFlag;
			}
			set
			{
				formatpainterFlag = value;
			}
				
		}

		[Browsable(false)]
		public Syncfusion.Windows.Forms.Diagram.Symbol InsSymbolTool
		{
			get
			{
				return insSymbolTool;
			}
			set
			{
				insSymbolTool = value;
			}
		}

		[Browsable(false)]
		public ContextMenu CanvasContextMenu
		{
			get
			{
				return this.labelContextMenu;
			}
		}

        public List<float> VerticalAnchorList
        {
            get {
                object obj = this.View.Properties.GetPropertyValue("VerticalAnchorList");
                List<float> verticalAnchorList;
                if (obj == null)
                {
                    verticalAnchorList = new List<float>();
                    this.View.Properties.SetPropertyValue("VerticalAnchorList",verticalAnchorList);
                }
                else
                {
                    verticalAnchorList = this.View.Properties.GetPropertyValue("VerticalAnchorList") as List<float>;
                }
                return  verticalAnchorList; }
        }

        public List<float> HorizontalAnchorList
        {
            get
            {
                object obj = this.View.Properties.GetPropertyValue("HorizontalAnchorList");
                List<float> horizontalAnchorList;
                if (obj == null)
                {
                    horizontalAnchorList = new List<float>();
                    this.View.Properties.SetPropertyValue("HorizontalAnchorList", horizontalAnchorList);
                }
                else
                {
                    horizontalAnchorList = this.View.Properties.GetPropertyValue("HorizontalAnchorList") as List<float>;
                }
                return horizontalAnchorList;
            }
        }
		#endregion

		private void setValueVisibility_Click(object sender, EventArgs e)
		{
			Symbol smbl = this.SelectionList.First as Symbol;
			if(smbl != null && SetLabelsVisibility != null)
				SetLabelsVisibility(smbl, e);

		}

		private void changeGridDimensions_Click(object sender, EventArgs e)
		{
			if(ChangeGridDimensions != null)
			{
				ChangeGridDimensions(sender,e);
			}
		}

		private void nodeCustomFormatting_Click(object sender, EventArgs e)
		{
			if(SetCustomFormat != null)
			{
				SetCustomFormat(sender,e);
			}
		}
	}
}
