using System;
using System.ComponentModel;
using System.Globalization;
using System.Runtime.Serialization;
using System.Windows.Forms;
using System.Diagnostics;
using System.Collections;
using System.Data;
using System.Reflection;
using System.Resources;
using System.IO;
using System.Runtime.Serialization.Formatters.Soap;
using System.Drawing;
using System.Drawing.Drawing2D;

using Syncfusion;
using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;
using Syncfusion.Windows.Forms.Tools;
using Symcon.Utils.MessageDispatcher;
//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.Lightridge.LRRUI.Controls
{
	[Serializable]	// Pallatte is Serilalizable
	public class SymbolsList : PaletteGroupBar//GroupBar//System.Windows.Forms.ListView
	{
		#region Fields

		private SymbolPalette plantEquipmentsPallette	=	new SymbolPalette();
        private SymbolPalette dashBoardControlsPallette = new SymbolPalette();
		private SymbolPalette headersPallette			=	new SymbolPalette();
		private SymbolPalette sourceSinkPalette			=	new SymbolPalette();
		//		private SymbolPalette gridPallette				=	new SymbolPalette();
		private SymbolPalette customPallette			=	new SymbolPalette();
		private SymbolPalette objectBrowser				=	new SymbolPalette();
		private SymbolPalette miscPalette				=	new SymbolPalette();
		private SymbolPalette cmplxEquipmentPalette		=	new SymbolPalette();
		private SymbolPalette agregatesPalette			=	new SymbolPalette();
		private SymbolPalette gridsPallette				=	new SymbolPalette();
		
		


		//private InsertSymbolTool insTool;
		private System.Windows.Forms.ListView listViewPlantEquipments;
        private System.Windows.Forms.ListView listViewDashBoardControls;
		private System.Windows.Forms.ListView listViewPlantHeaders;
		private System.Windows.Forms.ListView listViewSourceSink;
		private System.Windows.Forms.ListView listViewGrid;
		private System.Windows.Forms.ListView listViewCustom;
		private System.Windows.Forms.ListView listViewMisc;
		private System.Windows.Forms.ListView listViewCmplxEquip;
		private System.Windows.Forms.ListView listViewAgregates;

		private Button btnRemoveSymbol;
		private Button btnAddSymbol;
		private System.Windows.Forms.ImageList imgListAdRem;
		private System.ComponentModel.IContainer components;
		private ImageList imglstCustom;
		private ImageList imgLstMisc;
		private ImageList imgLstCmplxEquipment;
		private ImageList imgLstAgregates;
		private ImageList imglstPlantItems;
        private ImageList imglstDashBoardItems;
		private ImageList imglstHeaders;
		private ImageList imglistSourceSink;
		private ImageList imglstGrids;



		#endregion 

		#region Constructor


		/// <summary>
		/// This is a Constructor for Symbols which would be loaded onto the Pallette
		/// </summary>
		public SymbolsList()
		{
            this.SuspendLayout();
			InitializeComponent();
		
			InitializeSymbolList();
			
			InitializeButtons();
			
			InitializeListView();
			
			InitializePlantItemPallette();
			
			InitializeHeaderPallette();
			
			InitializeSourceSinkPallette();
			
			InitializeCustomPalette();
			
			InitializeMiscPallette();
			
			InitializeComplexEquipPallette();
			
			InitializeAggregatesPallette();

			InitializeGridPallette();
            this.ResumeLayout();

            InitializeDashBoardControlPallette(); 

			
		}

		private void InitializeSymbolList()
		{
			this.Text			=	"Symbols"; // The Text for the SymbolPallette
			this.BackColor		=	System.Drawing.Color.White; //Background Color of the Pallette
			this.VisualStyle	=	Syncfusion.Windows.Forms.VisualStyle.Office2003; // The Style ie Windows 2003 Style to be used for the Pallette
			this.StackedMode	=	true;// Stack Mode is set to true , this enables user to sho and hide pallettes
			this.Name			=	"Palettes"; // The Name that appears at the top of the pallette 
			this.GroupBarItemSelectionChanging+=new GroupBarItemSelectionChangingEventHandler(SymbolsList_GroupBarItemSelectionChanging);
			this.GroupBarItemHeight = 20;
		}

		
		private void InitializeButtons()
		{
			//
			//btnAddSymbol 
			//
			btnAddSymbol = new Button();
			btnAddSymbol.Height = 18;
			btnAddSymbol.Width = 52;
			btnAddSymbol.BackColor = SystemColors.Highlight;
			btnAddSymbol.ImageList = imgListAdRem;
			btnAddSymbol.ImageIndex =4;
			btnAddSymbol.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			btnAddSymbol.Location = new Point(btnAddSymbol.Location.X + 10,btnAddSymbol.Location.Y+5 ) ;
			btnAddSymbol.Click+=new EventHandler(btnAddSymbol_Click);

			btnRemoveSymbol = new Button();
			btnRemoveSymbol.Height = 18;
			btnRemoveSymbol.Width = 52;
			btnRemoveSymbol.BackColor = SystemColors.Highlight;
			//			btnRemoveSymbol.Text = "Remove";
			btnRemoveSymbol.ImageList = imgListAdRem;
			btnRemoveSymbol.ImageIndex =5;
			btnRemoveSymbol.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			btnRemoveSymbol.Location = new Point(btnAddSymbol.Location.X + 50,btnAddSymbol.Location.Y) ;
			btnRemoveSymbol.Click+=new EventHandler(btnRemoveSymbol_Click);
		}

	
		private void InitializeListView()
		{
			
			this.listViewPlantEquipments	=	new System.Windows.Forms.ListView();
            this.listViewDashBoardControls = new ListView();
			this.listViewPlantHeaders		=	new System.Windows.Forms.ListView();
			this.listViewSourceSink			=	new ListView();
			this.listViewGrid				=	new System.Windows.Forms.ListView();
			this.listViewCustom				=	new ListView();
			this.listViewMisc				=	new ListView();
			this.listViewCmplxEquip			=	new ListView();
			this.listViewAgregates			=	new ListView();

			
            
			listViewPlantEquipments.MultiSelect	= false;
            listViewDashBoardControls.MultiSelect = false;
			listViewPlantHeaders.MultiSelect	= false;
			listViewSourceSink.MultiSelect		= false;
			listViewGrid.MultiSelect			= false;
			listViewCustom.MultiSelect			= false;
			listViewMisc.MultiSelect			= false;
			listViewAgregates.MultiSelect		= false;
			listViewCmplxEquip.MultiSelect		= false;
			



			
			imglstPlantItems	= new ImageList();
            imglstDashBoardItems = new ImageList();
			imglstHeaders		= new ImageList();
			imglistSourceSink	= new ImageList();
			imglstGrids			= new ImageList();
			imglstCustom		= new ImageList();
			imgLstMisc			= new ImageList();
			imgLstAgregates		= new ImageList();
			imgLstCmplxEquipment = new ImageList();

			



			listViewPlantEquipments.LargeImageList		=	imglstPlantItems;
            listViewDashBoardControls.LargeImageList = imglstDashBoardItems;
			listViewPlantHeaders.LargeImageList			=	imglstHeaders;
			listViewSourceSink.LargeImageList			=   imglistSourceSink;
			listViewCustom.LargeImageList				=	imglstCustom;
			listViewMisc.LargeImageList					=	imgLstMisc;
			listViewGrid.LargeImageList					=	imglstGrids;
			listViewCmplxEquip.LargeImageList			=	imgLstCmplxEquipment;
			listViewAgregates.LargeImageList			=	imgLstAgregates;
			
			listViewPlantEquipments.ItemDrag+=new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);
			listViewPlantHeaders.ItemDrag+=new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);
			listViewSourceSink.ItemDrag+=new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);
			listViewGrid.ItemDrag+=new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);
			listViewCustom.ItemDrag+=new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);
			listViewMisc.ItemDrag+=new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);
			listViewAgregates.ItemDrag+=new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);
			listViewCmplxEquip.ItemDrag+=new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);
            listViewDashBoardControls.ItemDrag += new ItemDragEventHandler(listViewPlantEquipments_ItemDrag); 

		}

       

	
		private void InitializePlantItemPallette()
		{
			plantEquipmentsPallette = this.LoadMyPalette("Symcon.Lightridge.LRRUI.Controls.Symbols.Equipment.edp");//Calling Load Pallette Method to load Equipments Pallette
			int i = 0;
			foreach(INode nde in plantEquipmentsPallette.Nodes)
			{
				SymbolModel smblmdl = nde as SymbolModel;
				imglstPlantItems.Images.Add(smblmdl.LargeIcon);
				ListViewItem lvItem = new ListViewItem(nde.Name);
				lvItem.ImageIndex = i;
				this.listViewPlantEquipments.Items.Add(lvItem);
				smblmdl.AutoHidePorts = true;
				smblmdl.PlugInAssemblyName = "Symcon.Lightridge.LRRUI";
				smblmdl.PlugInClass = "Symcon.Lightridge.LRRUI.Controls.EquipmentProperties";
				i++;
			}
			GroupBarItem gbi = new GroupBarItem();
			this.Controls.Add(listViewPlantEquipments);
			gbi.Client = listViewPlantEquipments;
			gbi.Text = "Equipment";
			gbi.Tag = plantEquipmentsPallette;
			this.GroupBarItems.Add(gbi);
		}

        private void InitializeDashBoardControlPallette()
        {
            dashBoardControlsPallette = this.LoadMyPalette("Symcon.Lightridge.LRRUI.Controls.DashBoardControls.DashBoard.edp");//Calling Load Pallette Method to load DashBoard Pallette
            int i = 0;
            foreach (INode nde in dashBoardControlsPallette.Nodes)
            {
                SymbolModel smblmdl = nde as SymbolModel;
               
                ControlNode ctrlNode = smblmdl.Nodes.GetNodeByName("ControlNode")  as ControlNode;
                ctrlNode.ActivateStyle = ActivateStyle.None; 
                imglstDashBoardItems.Images.Add(smblmdl.LargeIcon);
                ListViewItem lvItem = new ListViewItem(nde.Name);
                lvItem.ImageIndex = i;
                this.listViewDashBoardControls.Items.Add(lvItem);
                smblmdl.AutoHidePorts = true;
                smblmdl.PlugInAssemblyName = ctrlNode.ControlAssemblyName;
                smblmdl.PlugInClass = ctrlNode.ControlClassName;
                i++;
            }
            GroupBarItem gbi = new GroupBarItem();
            this.Controls.Add(listViewDashBoardControls);
            gbi.Client = listViewDashBoardControls;
            gbi.Text = "DashBoard Controls";
            gbi.Tag = dashBoardControlsPallette;
            this.GroupBarItems.Add(gbi);
        }
		
		private void InitializeHeaderPallette()
		{
			headersPallette = this.LoadMyPalette("Symcon.Lightridge.LRRUI.Controls.Symbols.Systems.edp");//Calling Load Pallette Method to load Systems Pallette
			int i=0;
			foreach(INode nde in headersPallette.Nodes)
			{
				SymbolModel smblmdl = nde as SymbolModel;
				imglstHeaders.Images.Add(smblmdl.LargeIcon);
				ListViewItem lvItem = new ListViewItem(nde.Name);
				lvItem.ImageIndex = i;
				listViewPlantHeaders.Items.Add(lvItem);
				smblmdl.AutoHidePorts = true;
				smblmdl.PlugInAssemblyName = "Symcon.Lightridge.LRRUI";
				smblmdl.PlugInClass = "Symcon.Lightridge.LRRUI.Controls.SystemProperties";
				i++;
			}
			GroupBarItem gbi1 = new GroupBarItem();
			this.Controls.Add(listViewPlantHeaders);
			gbi1.Client = listViewPlantHeaders;
			gbi1.Text = "Headers";
			gbi1.Tag = headersPallette;
			this.GroupBarItems.Add(gbi1);
		}
		
		
		private void InitializeSourceSinkPallette()
		{
			sourceSinkPalette = this.LoadMyPalette("Symcon.Lightridge.LRRUI.Controls.Symbols.SourceSink.edp");//Calling Load Pallette Method to load Systems Pallette
			int i=0;
			foreach(INode nde in sourceSinkPalette.Nodes)
			{
				SymbolModel smblmdl = nde as SymbolModel;
				imglistSourceSink.Images.Add(smblmdl.LargeIcon);
				ListViewItem lvItem = new ListViewItem(nde.Name);
				lvItem.ImageIndex = i;
				listViewSourceSink.Items.Add(lvItem);
				smblmdl.AutoHidePorts = true;
				smblmdl.PlugInAssemblyName = "Symcon.Lightridge.LRRUI";
				smblmdl.PlugInClass = "Symcon.Lightridge.LRRUI.Controls.SourceSink";
				i++;
				
			}
			GroupBarItem gbi2 = new GroupBarItem();
			this.Controls.Add(listViewSourceSink);
			gbi2.Client = listViewSourceSink;
			gbi2.Text = "Source\\Sink";
			gbi2.Tag = sourceSinkPalette;

			this.GroupBarItems.Add(gbi2);

		}
		
		private void InitializeCustomPalette()
		{
			PaletteGroupView pgrv = new PaletteGroupView();
			pgrv.LoadPalette(Application.StartupPath +@"\Custom.edp");
			customPallette = pgrv.Palette;
			int i=0;
			if(customPallette.Nodes != null)
			{
				foreach(INode nde in customPallette.Nodes)
				{
					SymbolModel smblmdl = nde as SymbolModel;
					imglstCustom.Images.Add(smblmdl.LargeIcon);
					ListViewItem lvItem = new ListViewItem(nde.Name);
					lvItem.ImageIndex = i;
					listViewCustom.Items.Add(lvItem);
					smblmdl.AutoHidePorts = true;
					smblmdl.PlugInAssemblyName = "Symcon.Lightridge.LRRUI";
					smblmdl.PlugInClass = "Symcon.Lightridge.LRRUI.Controls.CustomProperties";
					i++;
				}
			}
			GroupBarItem gbi3 = new GroupBarItem();
			this.Controls.Add(listViewCustom);
			gbi3.Client = listViewCustom;
			gbi3.Text = "Custom";
			gbi3.Tag = customPallette;
			this.GroupBarItems.Add(gbi3);
			gbi3.Disposed+=new EventHandler(gbi3_Disposed);
		}
		
		private void InitializeMiscPallette()
		{
			miscPalette = this.LoadMyPalette("Symcon.Lightridge.LRRUI.Controls.Symbols.Lines1.edp");
			int i=0;
			if(miscPalette.Nodes != null)
			{
				foreach(INode nde in miscPalette.Nodes)
				{
					SymbolModel smblmdl = nde as SymbolModel;
					imgLstMisc.Images.Add(smblmdl.LargeIcon);
					ListViewItem lvItem = new ListViewItem(nde.Name);
					lvItem.ImageIndex = i;

					smblmdl.AutoHidePorts = true;
					smblmdl.PlugInAssemblyName = "Symcon.Lightridge.LRRUI";
					smblmdl.PlugInClass = "Symcon.Lightridge.LRRUI.Controls.MiscSymbols";
					listViewMisc.Items.Add(lvItem);
					i++;
				}
			}
			GroupBarItem gbi4 = new GroupBarItem();
			this.Controls.Add(listViewMisc);
			gbi4.Client = listViewMisc;
			gbi4.Text = "Misc.";
			gbi4.Tag = miscPalette;
			this.GroupBarItems.Add(gbi4);
		}
		
		private void InitializeComplexEquipPallette()
		{
			
			cmplxEquipmentPalette = this.LoadMyPalette("Symcon.Lightridge.LRRUI.Controls.Symbols.ComplexEqp.edp");
			int i=0;
			if(cmplxEquipmentPalette.Nodes != null)
			{
				foreach(INode nde in cmplxEquipmentPalette.Nodes)
				{
					SymbolModel smblmdl = nde as SymbolModel;
					imgLstCmplxEquipment.Images.Add(smblmdl.LargeIcon);
					ListViewItem lvItem = new ListViewItem(nde.Name);
					lvItem.ImageIndex = i;
					listViewCmplxEquip.Items.Add(lvItem);
					smblmdl.AutoHidePorts = true;
					smblmdl.PlugInAssemblyName = "Symcon.Lightridge.LRRUI";
					smblmdl.PlugInClass = "Symcon.Lightridge.LRRUI.Controls.EquipmentProperties";
					i++;
				}
			}
			GroupBarItem gbi5 = new GroupBarItem();
			this.Controls.Add(listViewCmplxEquip);
			gbi5.Client = listViewCmplxEquip;
			gbi5.Text = "Complex Equip.";
			gbi5.Tag = cmplxEquipmentPalette;
			this.GroupBarItems.Add(gbi5);
		}
		
		private void InitializeAggregatesPallette()
		{
			
			agregatesPalette = this.LoadMyPalette("Symcon.Lightridge.LRRUI.Controls.Symbols.Aggregates.edp");
			int i=0;
			if(agregatesPalette.Nodes != null)
			{
				foreach(INode nde in agregatesPalette.Nodes)
				{
					SymbolModel smblmdl = nde as SymbolModel;
					imgLstAgregates.Images.Add(smblmdl.LargeIcon);
					ListViewItem lvItem = new ListViewItem(nde.Name);
					lvItem.ImageIndex = i;
					listViewAgregates.Items.Add(lvItem);
					smblmdl.AutoHidePorts = true;
					smblmdl.PlugInAssemblyName = "Symcon.Lightridge.LRRUI";
					smblmdl.PlugInClass = "Symcon.Lightridge.LRRUI.Controls.Aggregates";
					i++;
				}
			}
			GroupBarItem gbi6 = new GroupBarItem();
			this.Controls.Add(listViewAgregates);
			gbi6.Client = listViewAgregates;
			gbi6.Text = "Aggregates";
			gbi6.Tag = agregatesPalette;
			this.GroupBarItems.Add(gbi6);
		}
		

		private void InitializeGridPallette()
		{
			gridsPallette = this.LoadMyPalette("Symcon.Lightridge.LRRUI.Controls.Symbols.Grid.edp");
			int i=0;
			if(gridsPallette.Nodes != null)
			{
				foreach(INode nde in gridsPallette.Nodes)
				{
					SymbolModel smblmdl = nde as SymbolModel;
					imglstGrids.Images.Add(smblmdl.LargeIcon);
					ListViewItem lvItem = new ListViewItem(nde.Name);
					lvItem.ImageIndex = i;
					listViewGrid.Items.Add(lvItem);
					smblmdl.AutoHidePorts = true;
					smblmdl.PlugInAssemblyName = "Symcon.Lightridge.LRRUI";
					smblmdl.PlugInClass = "Symcon.Lightridge.LRRUI.Controls.DynamicGridcontainer";
					i++;
				}
			}
			GroupBarItem gbi7 = new GroupBarItem();
			this.Controls.Add(listViewGrid);
			gbi7.Client = listViewGrid;
			gbi7.Text = "Grid";
			gbi7.Tag = gridsPallette;
			this.GroupBarItems.Add(gbi7);
		}
		#endregion

		
		protected override void Dispose(bool disposing)
		{

			listViewPlantEquipments.ItemDrag-=new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);
			listViewPlantHeaders.ItemDrag-=new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);
			listViewGrid.ItemDrag-=new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);
			listViewCustom.ItemDrag-=new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);
			listViewMisc.ItemDrag-=new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);
			listViewAgregates.ItemDrag-=new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);
			listViewCmplxEquip.ItemDrag-=new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);
            listViewDashBoardControls.ItemDrag -= new ItemDragEventHandler(listViewPlantEquipments_ItemDrag);

			base.Dispose (disposing);
		}

		#region Private Methods
		/// <summary>
		/// The Embedded resource filename for the pallette is passed onto LoadPallette Method and the pallette loaded with the filename is returned
		/// </summary>
		/// <param name="fileName"></param>
		/// <returns></returns>
		private SymbolPalette LoadMyPalette(string fileName)
		{
			SymbolPalette	pal			=	null;
			Stream			iStream		=	Assembly.GetExecutingAssembly().GetManifestResourceStream(fileName);
			SoapFormatter	formatter	=	new SoapFormatter();
			try
			{
				System.AppDomain.CurrentDomain.AssemblyResolve +=new ResolveEventHandler(DiagramBaseAssembly.AssemblyResolver);
				pal = (SymbolPalette) formatter.Deserialize(iStream);
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
				pal = null;
			}
			finally
			{
				iStream.Close();
				System.AppDomain.CurrentDomain.AssemblyResolve -= new ResolveEventHandler(DiagramBaseAssembly.AssemblyResolver);
			}
			return pal;
		}
		#endregion

		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SymbolsList));
			this.imgListAdRem = new System.Windows.Forms.ImageList(this.components);
			// 
			// ilNavPaneItems
			// 
			this.ilNavPaneItems.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ilNavPaneItems.ImageStream")));
			// 
			// imgListAdRem
			// 
			this.imgListAdRem.ImageSize = new System.Drawing.Size(18, 18);
			this.imgListAdRem.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgListAdRem.ImageStream")));
			this.imgListAdRem.TransparentColor = System.Drawing.Color.Transparent;

		}



		private void listViewPlantEquipments_ItemDrag(object sender, ItemDragEventArgs e)
		{
			if(this.Canvas != null)
			{
				try
				{
					ListViewItem lsvItem =  e.Item as ListViewItem;
					SymbolModel sModel = null;
					if(this.SelectedItem == 0)
					{
						INode nd =  plantEquipmentsPallette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = plantEquipmentsPallette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					
					}
					else if(this.SelectedItem == 1)
					{
						INode nd =  headersPallette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = headersPallette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					
					}
					else if(this.SelectedItem == 2)
					{
						INode nd =  sourceSinkPalette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = sourceSinkPalette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					
					}

					else if(this.SelectedItem == 3)
					{
						INode nd =  customPallette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = customPallette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					}
					else if(this.SelectedItem == 4)
					{
						INode nd =  miscPalette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = miscPalette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					}
					else if(this.SelectedItem == 5)
					{
						INode nd =  cmplxEquipmentPalette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = cmplxEquipmentPalette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					}
					else if(this.SelectedItem == 6)
					{
						INode nd =  agregatesPalette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = agregatesPalette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					}
					else if(this.SelectedItem == 7)
					{
						INode nd =  gridsPallette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = gridsPallette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					}
                    else if (this.SelectedItem == 8)
                    {
                        INode nd = dashBoardControlsPallette.Nodes.GetNodeByName(lsvItem.Text);
                        sModel = dashBoardControlsPallette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
                    }
				

					Symbol smbl = sModel.CreateSymbol();
                    if (smbl == null)
                    {
                        ControlNode ctrlNode = sModel.Nodes.GetNodeByName("ControlNode") as ControlNode;
                        ControlNode newCtrlNode = ctrlNode.Clone() as ControlNode;
                        Control ctrl = (Control)ctrlNode.GetType().GetProperty("Control").GetValue(newCtrlNode, null);
                        DashBoardControlProperties dashBoardControlProperties = new DashBoardControlProperties(ctrl);
                        dashBoardControlProperties.Nodes.Add(newCtrlNode);
                        smbl = dashBoardControlProperties;
                    }
					smbl.SetPropertyValue("SymbolName", sModel.Name);
					//this.Canvas.Controller.RegisterTool(this.insTool);//new InsertNodeTool("InsertItem", nde.GetType()));
					this.Canvas.InsSymbolTool.Symbol = smbl;
					//this.insTool.Symbol = smbl;
					//			//this.DoDragDrop(smbl,DragDropEffects.All);
					//			MessageBox.Show(nd.FullName);
					this.Canvas.ActivateTool("InsertItem");

					//			//this.Canvas.Refresh();
					//			this.canvas.Model.AppendChild(nd);
					//			this.canvas.Refresh();
					////						
					////			
					////			SymbolModel smblMdl = myp.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					////			//MessageBox.Show(smblMdl.PlugInAssembly);
					////			//InsertNodesCmd ins = new InsertNodesCmd();
					////			//ins.Do(this.Canvas);
					////			//smblMdl.Location = this.diagram1.View.DeviceToView( pt );
					////			this.canvas.Model.AppendChild(nd);
					////			this.canvas.Refresh();
					///
				}
				catch(Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}

		}

        private void listViewDashBoardControls_ItemDrag(object sender, ItemDragEventArgs e)
        {
            if(this.Canvas != null)
			{
				try
				{
					ListViewItem lsvItem =  e.Item as ListViewItem;
					SymbolModel sModel = null;
					if(this.SelectedItem == 0)
					{
						INode nd =  plantEquipmentsPallette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = plantEquipmentsPallette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					
					}
					else if(this.SelectedItem == 1)
					{
						INode nd =  headersPallette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = headersPallette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					
					}
					else if(this.SelectedItem == 2)
					{
						INode nd =  sourceSinkPalette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = sourceSinkPalette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					
					}

					else if(this.SelectedItem == 3)
					{
						INode nd =  customPallette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = customPallette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					}
					else if(this.SelectedItem == 4)
					{
						INode nd =  miscPalette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = miscPalette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					}
					else if(this.SelectedItem == 5)
					{
						INode nd =  cmplxEquipmentPalette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = cmplxEquipmentPalette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					}
					else if(this.SelectedItem == 6)
					{
						INode nd =  agregatesPalette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = agregatesPalette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					}
					else if(this.SelectedItem == 7)
					{
						INode nd =  gridsPallette.Nodes.GetNodeByName(lsvItem.Text);
						sModel = gridsPallette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
					}
                    else if (this.SelectedItem == 8)
                    {
                        INode nd = dashBoardControlsPallette.Nodes.GetNodeByName(lsvItem.Text);
                        sModel = dashBoardControlsPallette.Nodes.GetNodeByName(lsvItem.Text) as SymbolModel;
                    }
                    

					Symbol smbl = sModel.CreateSymbol();
                    //For Dashboard Controls.
                    if (smbl == null)
                    {
                        ControlNode ctrlNode = sModel.Nodes.GetNodeByName("ControlNode") as ControlNode;
                        ControlNode newCtrlNode = ctrlNode.Clone() as ControlNode;
                        Control ctrl = (Control)ctrlNode.GetType().GetProperty("Control").GetValue(newCtrlNode, null);
                        //ctrl = Activator.CreateInstance(ctrl.GetType()) as Control;
                        DashBoardControlProperties dashBoardControlProperties = new DashBoardControlProperties(ctrl);
                       
                        //newCtrlNode.Control = ctrl;
                        dashBoardControlProperties.Nodes.Add(newCtrlNode);
                        dashBoardControlProperties.SetPropertyValue("SymbolName", sModel.Name);
                        this.Canvas.InsSymbolTool.Symbol = dashBoardControlProperties;
                    }
					this.Canvas.ActivateTool("InsertItem");
				}
				catch(Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}

        }


		private Canvas canvas;
		public Canvas Canvas
		{
			get
			{
				return canvas;
				
			}
			set
			{
				this.canvas = value;
			}
		}

		private void SymbolsList_GroupBarItemSelectionChanging(object sender, GroupBarItemSelectionChangingEventArgs args)
		{
			if(args.NewSelected == 3)
			{
				
				//this.GroupBarItems[2].Text = "";
				//btnAddSymbol.Dock = System.Windows.Forms.DockStyle.Top;
				this.Controls.Add(btnAddSymbol);
				this.Controls.Add(btnRemoveSymbol);
			}
			else if(args.OldSelected == 3)
			{
				//this.GroupBarItems[3].Text = "Custom";
				this.Controls.Remove(btnAddSymbol);
				this.Controls.Remove(btnRemoveSymbol);
			}
		}

		private void btnAddSymbol_Click(object sender, EventArgs e)
		{
			OpenFileDialog opn = new OpenFileDialog();
			opn.Filter = "Windows Bitmaps(bmp)|*.bmp|JPEG Files(*.jpg)|*.jpg|Graphical Interchange Format Files(*.gif)|*.gif|Portable Network Graphics File(*.png)|*.png|Enhanced Metafiles(*.emf)|*.emf";;
			
			opn.Title= "Select Image File";
			if (opn.ShowDialog(this) == DialogResult.OK)
			{
				Stream str = opn.OpenFile();
				System.Drawing.Image _image = System.Drawing.Image.FromStream(str);
				BitmapNode bmpNode = new BitmapNode(str);
				float nodeHeight = 40;
				float nodeWidth = 40;

				ProcesDimensions(bmpNode,out nodeHeight,out nodeWidth);
				bmpNode.Height = nodeHeight;
				bmpNode.Width = nodeWidth;
				SymbolModel customSymbolModel = this.customPallette.AddSymbol("Custom");
				Symbol smbl = new Symbol();
				smbl.AppendChild(bmpNode);
				for (int i = 0; i < 3; i++)
				{
					for	(int j = 0; j < 3; j++)
					{	


						PointF ptworld = new PointF((i * bmpNode.Height/2)+3, (j * bmpNode.Width/2)+3);
						PointF[] pts = new PointF[] {ptworld};
						Matrix worldxform = bmpNode.WorldTransform;
						worldxform.Invert();
						worldxform.TransformPoints(pts);
						CirclePort cPort = new CirclePort(pts[0]);
						smbl.Ports.Add(cPort);
						//						CirclePort cMP = new CirclePort(); 
						//						cMP.Location = new PointF((i * 40/2)+3,(j * 40/2)+3);
						//						smbl.AppendChild(cMP);
					}
				}
				foreach(INode node in smbl.Nodes)
				{
					customSymbolModel.DefaultLayer.Add(node);
				}
				customSymbolModel.LargeIcon = _image;
				customSymbolModel.PlugInAssembly = "Symcon.Lightridge.LRRUI";
				customSymbolModel.PlugInClass = "Symcon.Lightridge.LRRUI.Controls.CustomProperties";
				//int slashPos = opn.FileName.LastIndexOf("\\");
				//string fileName = opn.FileName.Substring(slashPos + 1);
				string fileName  = Path.GetFileNameWithoutExtension(opn.FileName);
				customSymbolModel.Name = fileName;
			
				customSymbolModel.AutoHidePorts = true;

				

				//SymbolModel smblmdl = nde as SymbolModel;
				imglstCustom.Images.Add(_image);
				ListViewItem lvItem = new ListViewItem(customSymbolModel.Name);
				listViewCustom.Items.Add(lvItem);
				lvItem.ImageIndex = imglstCustom.Images.Count-1;
				listViewCustom.Refresh();
			}
		}

		private void ProcesDimensions(BitmapNode bmpNode,out float  nodeHeight,out float nodeWidth )
		{
			nodeHeight = bmpNode.Height;
			nodeWidth = bmpNode.Width;
			while(nodeHeight  > 50)
			{
				nodeHeight = nodeHeight/2;
				nodeWidth = nodeWidth/2;
			}
		}

		private void btnRemoveSymbol_Click(object sender, EventArgs e)
		{
			try
			{
			
				//if(listViewCustom.SelectedItems[0] != null)
				//{
				SymbolModel sModel = customPallette.Nodes.GetNodeByName(listViewCustom.SelectedItems[0].Text) as SymbolModel;
				//Symbol sMbl = customPallette.Nodes.GetNodeByName(listViewCustom.SelectedItems[0].Text) as Symbol;
				if(MessageBox.Show("Are you sure you want to delete " + listViewCustom.SelectedItems[0].Text + "?", "Confirm Symbol Delete", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1) == DialogResult.Yes)
				{
					this.customPallette.RemoveSymbol(sModel);
					this.listViewCustom.Items.Remove(listViewCustom.SelectedItems[0]);
				}

				//}
			}
			catch
			{

			}
		}

		private void gbi3_Disposed(object sender, EventArgs e)
		{
			FileStream oStream;
			SoapFormatter formatter;
			//customPallette.fi
			try
			{
				
				Assembly asm = Assembly.GetExecutingAssembly();

				
				 
				string pth = Path.GetDirectoryName(asm.Location.ToString(Symcon.BusinessObjects.SymConverter.Culture));
				oStream = new FileStream(pth + "\\" +customPallette.FullName + ".edp", FileMode.Create);
			}
			catch
			{

				oStream = null;
				LRRMessagBox.ShowMessage(this, "SID_SAVE_CUSTOM");	
			}

			if (oStream != null)
			{
				formatter = new SoapFormatter();
				formatter.AssemblyFormat = System.Runtime.Serialization.Formatters.FormatterAssemblyStyle.Simple;
				formatter.Serialize(oStream, customPallette);
				oStream.Close();
			}
		}

	}
}