using System;
using System.ComponentModel;
using System.Globalization;
using System.Runtime.Serialization;
using System.Windows.Forms;
using System.Diagnostics;
using System.Collections;
using System.Reflection;
using System.Xml.Serialization;
using System.Drawing;
//using System.Drawing.Drawing2D;
using Symcon.LightRidge.BusinessObjects.TypeConverters;
using PerpetuumSoft.Framework.Model;
using PerpetuumSoft.Instrumentation.Model;
using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;
using System.Drawing.Drawing2D;
//using Symcon.Lightridge.LRRUI.Controls.Tools;
namespace Symcon.Lightridge.LRRUI.Controls
{
	[Serializable()]
    public class SystemProperties : Node
	{
		#region Constructor
		/// <summary>
		/// Default constructor.
		/// </summary>
        public SystemProperties()
            : base()
        {
            SetPropertyTable();
            this.ID = Guid.NewGuid().ToString();
            ArryIndexedProps = new ArrayList();


            for (int i = 0; i < 4; i++)
            {
                ArryIndexedProps.Add("Null");
            }
            SymbolsUtils.CreateLabels(this);
        }

		/// <summary>
		/// Copy constructor.
		/// </summary>
		/// <param name="src"></param>
        public SystemProperties(SystemProperties src)
            : base(src)
        {
            try
            {
                SystemProperties sourceSysProps = src as SystemProperties;
                SystemProperties targetSysProps = this;
                targetSysProps.PT = null;
                targetSysProps.MasterPlantItem = null;
                targetSysProps.PlantItem = null;

                targetSysProps.FillStyle.AlphaFactor = sourceSysProps.FillStyle.AlphaFactor;
                targetSysProps.FillStyle.Color = sourceSysProps.FillStyle.Color;
                targetSysProps.FillStyle.GradientAngle = sourceSysProps.FillStyle.GradientAngle;
                targetSysProps.FillStyle.GradientBounds = sourceSysProps.FillStyle.GradientBounds;
                targetSysProps.FillStyle.GradientStartColor = sourceSysProps.FillStyle.GradientStartColor;
                targetSysProps.FillStyle.Texture = sourceSysProps.FillStyle.Texture;
                targetSysProps.FillStyle.TextureWrapMode = sourceSysProps.FillStyle.TextureWrapMode;
                targetSysProps.FillStyle.Type = sourceSysProps.FillStyle.Type;

                targetSysProps.EditStyle.AllowMove = sourceSysProps.EditStyle.AllowMove;
                targetSysProps.EditStyle.AllowResize = sourceSysProps.EditStyle.AllowResize;
                targetSysProps.EditStyle.AllowRotate = sourceSysProps.EditStyle.AllowRotate;
                targetSysProps.EditStyle.AllowSelect = sourceSysProps.EditStyle.AllowSelect;
                targetSysProps.EditStyle.AllowVertexEdit = sourceSysProps.EditStyle.AllowVertexEdit;
                targetSysProps.EditStyle.DefaultHandleEditMode = sourceSysProps.EditStyle.DefaultHandleEditMode;

                targetSysProps.LineStyle.DashCap = sourceSysProps.LineStyle.DashCap;
                targetSysProps.LineStyle.DashOffset = sourceSysProps.LineStyle.DashOffset;
                targetSysProps.LineStyle.DashStyle = sourceSysProps.LineStyle.DashStyle;
                targetSysProps.LineStyle.EndCap = sourceSysProps.LineStyle.EndCap;
                targetSysProps.LineStyle.LineColor = sourceSysProps.LineStyle.LineColor;
                targetSysProps.LineStyle.LineJoin = sourceSysProps.LineStyle.LineJoin;
                targetSysProps.LineStyle.LineWidth = sourceSysProps.LineStyle.LineWidth;
                targetSysProps.LineStyle.MiterLimit = sourceSysProps.LineStyle.MiterLimit;

                targetSysProps.Width = sourceSysProps.Width;
                targetSysProps.Height = sourceSysProps.Height;
                targetSysProps.Length = sourceSysProps.Length;

                targetSysProps.Visible = sourceSysProps.Visible;

                targetSysProps.AutoHidePorts = sourceSysProps.AutoHidePorts;
                targetSysProps.BorderColor = sourceSysProps.BorderColor;

                targetSysProps.BorderWidth = sourceSysProps.BorderWidth;
                targetSysProps.Transparency = sourceSysProps.Transparency;
                targetSysProps.ArryIndexedProps = null;
                targetSysProps.ArryIndexedProps = sourceSysProps.ArryIndexedProps.Clone() as ArrayList;
                for (int i = 0; i < 4; i++)
                {
                    targetSysProps.ArryIndexedProps[i] = "Null";
                }
                SetPropertyTable();


            }
            catch (Exception ex)
            {

            }
        }

		/// <summary>
		/// Serialization constructor for the MySymbol class.
		/// </summary>
		/// <param name="info">Serialization state information</param>
		/// <param name="context">Streaming context information</param>
        protected SystemProperties(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
            // The Serialization constructor is invoked during deserialization or during a drag & drop operation.
            // If the MySymbol type has serializable members, then initialize them with the serialized data 
            // obtained from the SerializationInfo param
        }

		// Override SymbolBase.GetObjectData() and populate the SerializationInfo param 
		// with the data (if any) that belongs to the MySymbol type . This data will be 
		// serialized as a part of the Symbol object.

		#endregion

		#region Overrides
		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}
        
		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>Copy of the object this method is invoked against</returns>
		public override object Clone()
		{
			return new SystemProperties(this);
		}

        protected override void DoSizeRelatedActions(SizeF szOldSize, SizeF szNewSize)
        {
            base.DoSizeRelatedActions(szOldSize, szNewSize);
            for (int j = this.Ports.Count; j > 0; j--)
            {
                this.Ports.Remove(this.Ports[j - 1]);
            }
            float xoffset = this.X;
            while (xoffset < (this.X + this.Size.Width))
            {
                PointF ptworld = new PointF(xoffset, this.PinPoint.Y + this.Height / 2);
                PointF[] pts = new PointF[] { ptworld };
                Matrix worldxform = this.WorldTransform;
                worldxform.Invert();
                worldxform.TransformPoints(pts);
                CirclePort cPort = new CirclePort(pts[0]);
                this.Ports.Add(cPort);
                xoffset += 10f;
            } 
        }

        //protected override void OnBoundsChanged(Syncfusion.Windows.Forms.Diagram.BoundsInfo evtArgs)
        //{
        //    base.OnBoundsChanged (evtArgs);
        //    for(int j = this.Ports.Count ; j>0; j--)
        //    {
        //        this.Ports.Remove(this.Ports[j-1]);
        //    }                                         
        //    float xoffset = this.X;
        //    while(xoffset < (this.X + this.Width))
        //    {
        //        PointF ptworld = new PointF(xoffset, this.Location.Y + this.Height / 2);
        //        PointF[] pts = new PointF[] {ptworld};
        //        Matrix worldxform = this.WorldTransform;
        //        worldxform.Invert();
        //        worldxform.TransformPoints(pts);
        //        CirclePort cPort = new CirclePort(pts[0]);
        //        this.Ports.Add(cPort);
        //        xoffset += 10f;                                             
        //    } 
        //}
      
		#endregion

		#region	Public Properties 
		
		/// <summary>
		/// Link to Navigate to when symbol is double-clicked
		/// </summary>
		[Browsable(true),TypeConverter(typeof(LinkTypeConverter)),ReadOnly(false)]
		public Symcon.LightRidge.BusinessObjects.GraphicalLink Link
		{
			get
			{
				object value = this.GetPropertyValue("Link");
				if (value != null && value.GetType() != typeof(string))
				{
					return (Symcon.LightRidge.BusinessObjects.GraphicalLink) value;
				}
				return null;
			}
			set
			{
				this.SetPropertyValue("Link", value);
				this.Labels["Link"].Text = Link.Name;
			}
		}


		
		[Browsable(true),ReadOnly(false)]
		public float BorderWidth
		{
			get
			{
				return this.LineStyle.LineWidth;
			}
			set
			{
				this.LineStyle.LineWidth = value;
			}
		}

		[Browsable(true),ReadOnly(false)]
		public bool LockAspectRatio
		{
			get
			{
				object value = this.GetPropertyValue("LockAspectRatio");
				if (value != null)
				{
					return (bool) value;
				}
				return false;
			}
			set
			{
				this.SetPropertyValue("LockAspectRatio", value);
			}
		}



		
		[Browsable(true),ReadOnly(false)]
		public int Transparency
		{
			get
			{
				return this.FillStyle.AlphaFactor;
			}
			set
			{
				this.FillStyle.AlphaFactor = value;
			}
		}


		/// <summary>
		/// Link Id
		/// </summary>
		[Browsable(false),ReadOnly(false)]
		public string LinkID
		{
			get
			{
				object value = this.GetPropertyValue("LinkID");
				if (value != null)
				{
					return (string) value;
				}
				return null;
			}
			set
			{
				this.SetPropertyValue("LinkID", value);
			}
		}





		[Browsable(true),ReadOnly(false)]
		public Color BorderColor
		{
			get
			{
				return this.LineStyle.LineColor;
			}
			set
			{
				this.LineStyle.LineColor = value;
			}
		}


		/// <summary>
		/// The Width of Symbol
		/// </summary>
		[Browsable(true)]
		public float Length
		{
			get
			{
				return (float) base.Width;
			}
			set
			{
                if (value == 0)
                {
                    value = .01f;
                }
				base.Width = value;
			}
		}

		/// <summary>
		/// The Width of Symbol
		/// </summary>
		[Browsable(true)]
		public new float Height
		{
			get
			{
				return (float) base.Height;
			}
			set
            {
                if (value == 0)
                {
                    value = .01f;
                }
                base.Height = value;
			}
		}



		/// <summary>
		/// The X Cordinate of Symbol w.r.t the Canvas
		/// </summary>
		[Browsable(true)]
		public new float X
		{
			get
			{
				return base.BoundingRectangle.X;
			}
			set
			{
                base.PinPoint = new PointF( value + base.Size.Width / 2, PinPoint.Y);
			}
		}


		/// <summary>
		/// The Y Cordinate of Symbol w.r.t the Canvas
		/// </summary>
		[Browsable(true)]
		public new float Y
		{
			get
			{
				return base.BoundingRectangle.Y;
			}
			set
			{
				base.PinPoint = new PointF( PinPoint.X , value + this.Size.Height /2);
			}
		}



		/// <summary>
		/// Set of Labels 
		/// </summary>
		[Browsable(false)]
        //public LabelCollection BoundProperties
        //{
        //    get
        //    {
        //        return base.Labels;
        //    }
        //}


		/// <summary>
		/// The Type of Master Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(true),TypeConverter(typeof(SymbolTypeConverter)), 
		CategoryAttribute("Binding Information")]
		public Symcon.LightRidge.BusinessObjects.MasterPlantItem MasterPlantItem
		{
			get
			{
				object value = this.GetPropertyValue("MasterPlantItem");
				if (value != null)
				{
					return (Symcon.LightRidge.BusinessObjects.MasterPlantItem) value;
				}
				return null;
			}
			set
			{
				this.SetPropertyValue("MasterPlantItem", value);
				this.SetPropertyValue("PlantItem", null);
			}
		}


		/// <summary>
		/// The Type of Master Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(false),TypeConverter(typeof(SymbolTypeConverter)), 
		CategoryAttribute("Binding Information")]
		public string ItemType
		{
			get
			{
				object value = this.GetPropertyValue("ItemType");
				if (value != null)
				{
					return (string) value;
				}
				return null;
			}
			set
			{
				this.SetPropertyValue("ItemType", value);
				this.SetPropertyValue("SiteItem", null);
			}
		}


		/// <summary>
		/// The Type of Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(true),TypeConverter(typeof(ObjectNameConverter)), 
		CategoryAttribute("Binding Information")]
		public Symcon.LightRidge.BusinessObjects.SiteItem PlantItem
		{
			get
			{
				object value = this.GetPropertyValue("PlantItem");
				if (value != null)
				{
					return (Symcon.LightRidge.BusinessObjects.SiteItem) value;
				}
				return null;
			}
			set
			{
				this.SetPropertyValue("PlantItem", value);
			}
		}



		/// <summary>
		/// The Type of Plant Item
		/// Associated with this symbol
		/// </summary>
		[Browsable(false),TypeConverter(typeof(ObjectNameConverter)), 
		CategoryAttribute("Binding Information")]
		public string SiteItem
		{
			get
			{
				object value = this.GetPropertyValue("SiteItem");
				if (value != null)
				{
				return (string) value;
				}
				return null;
			}
			set
			{
				this.SetPropertyValue("SiteItem", value);
			}
		}
		
		/// <summary>
		/// PropertyTable Associated With the symbol
		/// </summary>
		[Browsable(false)]
		public PropertyTable PT
		{
			get
			{
				object value = this.GetPropertyValue("PT");
				if (value != null)
				{
					return (PropertyTable) value;
				}
				PT = new PropertyTable();
				return null;
			}
			set
			{
				try
				{
					this.SetPropertyValue("PT", value);
				}
				catch(Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}
		}

		[Browsable(false), ReadOnly(false)]
		public string SymbolName 
		{
			get
			{
				object value = this.GetPropertyValue("SymbolName");
				if (value != null)
				{
					return (string) value;
				}
				return "Test";
			}
			set
			{
				try
				{
					this.SetPropertyValue("SymbolName", value);
				}
				catch(Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}
		}

		[Browsable(false),ReadOnly(false)]
		public ArrayList ArryIndexedProps
		{
			get
			{
				object value = this.GetPropertyValue("ArryIndexedProps");
				if (value != null)
				{
					return (ArrayList) value;
				}
				return null;
			}
			set
			{
				this.SetPropertyValue("ArryIndexedProps", value);
			}
				
		}

		[Browsable(false), ReadOnly(false)]
		public string ID
		{
			get
			{
				object value = this.GetPropertyValue("ID");
				if (value != null)
				{
					return (string) value;
				}
				return null;
			}
			set
			{
				try
				{
					this.SetPropertyValue("ID", value);
				}
				catch(Exception ex)
				{
					Debug.Assert(false, ex.Message);
				}
			}
		}

		#endregion

		#region Overrides


		#endregion

		#region Methods

		private void SetPropertyTable()
		{
			if(PT == null)
			{
				try
				{
					PropertyInfo[] properties =	this.GetType().GetProperties(BindingFlags.Instance | BindingFlags.DeclaredOnly | BindingFlags.Public);
				
					foreach	(PropertyInfo property in properties)
					{
						BrowsableAttribute[] attr = property.GetCustomAttributes(typeof(BrowsableAttribute),false) as BrowsableAttribute[];
						if(attr.Length > 0)
							if(((BrowsableAttribute)attr[0]).Browsable == false)
								continue;
						string propname	= property.Name;
						if(property.Name == "MasterPlantItem")
						{
							//PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Select the Type of Symbol" ,this.GetPropertyValue(property.Name),"",typeof(SymbolTypeConverter),this));
							PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Lists of Master Plant Item" ,this.GetPropertyValue(property.Name),"",typeof(SymbolTypeConverter),this));
						}
						else if(property.Name == "PlantItem" )
						{
							//PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Lists the Bound objects of selected type" ,this.GetPropertyValue(property.Name),"",typeof(ObjectNameConverter),this));
							PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Binding Information","Lists the Plant Item objects of Selected Master Plant Item",this.GetPropertyValue(property.Name),"",typeof(ObjectNameConverter),this));
							//siteitemps = new PropertySpec("PlantItem",typeof(SiteItem),"Binding Information","Lists the Plant Item objects of Selected Master Plant Item" ,si,"",typeof(Symcon.LightRidge.BusinessObjects.TypeConverters.ObjectNameConverter),sm);
						}
						else if(property.Name == "Link")
						{
							PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"Link","Select the Link for the Symbol" ,this.GetPropertyValue(property.Name),"",typeof(LinkTypeConverter),this));
						}
						else
						{
							PT.Properties.Add(new PropertySpec(property.Name,property.PropertyType,"General	Properties","Sets the " + property.Name + " property of selected symbol",this.GetPropertyValue(property.Name),"","", this));
						}
					}
				}	
				catch(Exception	ex)
				{
					Debug.Assert(false,ex.Message);
				}
			}
		}

		#endregion

		#region Fields
		private string					id;

		#endregion
	}
}
