using System;
using Syncfusion.Windows.Forms.Diagram;
using System.Drawing;
//using System.Drawing.Design;
//using System.Drawing.Drawing2D;
using System.Runtime.Serialization;
using System.Drawing.Drawing2D;
using System.ComponentModel;
using PerpetuumSoft.Framework.Model;

//using Syncfusion.Windows.Forms.Design;

namespace Symcon.Lightridge.LRRUI.Controls.Tools
{
	[Serializable]
	public class SimpleLink : LineConnector
	{
		#region Fields
		//private EndPointDecorator _endPointDecorator  = new EndPointDecorator(EndPointVisuals.ClosedArrow);
		//private EndPointDecorator _startPointDecorator  = new EndPointDecorator(EndPointVisuals.ClosedArrow);
//		private PolyLine _line;
		#endregion

		#region Constructors


        public SimpleLink(PointF ptStart, PointF ptEnd)
            : base(ptStart, ptEnd)
		{

		}


        public SimpleLink(PointF[] pts)
            : base(pts)
        {
            
        }


        //public SimpleLink(LineConnector shapeType)
        //    : base(shapeType)
        //{

        //}		

        //public SimpleLink(IPoints linkPoints):base(linkPoints)
        //{

        //}

		/// <summary>
		/// Copy constructor.
		/// </summary>
		/// <param name="src">Source object to copy from.</param>
        public SimpleLink(SimpleLink src)
            : base(src)
        {
        }

		/// <summary>
		/// Serialization constructor for symbols.
		/// </summary>
		/// <param name="info">Serialization state information.</param>
		/// <param name="context">Streaming context information.</param>
        protected SimpleLink(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }

		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>Copy of the object this method is invoked against.</returns>
		public override object Clone()
		{
			return new SimpleLink(this);
		}

		

		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}

		#endregion

		#region Properties

        public override void OnVertexChanged(VertexChangeType changeType, int nVertexIdx, PointF ptLocation)
        {
            base.OnVertexChanged(changeType, nVertexIdx, ptLocation);
        }

        //protected override void OnMoveVertex(VertexChangedEventArgs evtArgs)
        //{
        //    try
        //    {
        //        base.OnMoveVertex (evtArgs);
        //    }
        //    catch
        //    {

        //    }
        //}

        //[Category("LineCap"),Editor(typeof(Syncfusion.Windows.Forms.Diagram.EndPointDecoratorEditor),typeof(System.Drawing.Design.UITypeEditor)),TypeConverter(typeof(EndPointDecoratorConverter))]
        //public EndPointDecorator EndCap
        //{
        //    get
        //    {
        //        return this.HeadDecorator;
        //    }
        //    set
        //    {
        //        this.HeadDecorator = value;
        //        if(this.HeadDecorator != null)
        //        {
        //            //this.HeadDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
        //            this.HeadDecorator.FillStyle.Color = this.LineStyle.LineColor;
        //        }
        //    }
        //}


        //[Category("LineCap"), Editor(typeof(Syncfusion.Windows.Forms.Diagram.EndPointDecoratorEditor),typeof(System.Drawing.Design.UITypeEditor)),TypeConverter(typeof(EndPointDecoratorConverter))]
        //public EndPointDecorator StartCap
        //{
        //    get
        //    {
        //        return this.TailDecorator;
        //    }
        //    set
        //    {
        //        this.TailDecorator = value;
        //        if(this.TailDecorator != null)
        //        {
        //            //this.HeadDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
        //            this.TailDecorator.FillStyle.Color = this.LineStyle.LineColor;
        //        }
        //    }
        //}



		

		[Category("LineCap"),TypeConverter(typeof(SizeConverter))]
		public Size EndCapSize
		{
			get
			{
				if(this.HeadDecorator != null)
					return this.HeadDecorator.Size.ToSize();
				else 
					return new Size(0,0);

			}
			set
			{
				this.HeadDecorator.Size = value;
			}
		}


		[Category("LineCap"),DefaultValue(typeof(Size),null),TypeConverter(typeof(SizeConverter))]
		public Size StartCapSize
		{
			get
			{
				if(this.TailDecorator != null)
					return this.TailDecorator.Size.ToSize();
				else 
					return new Size(0,0);
			}
			set
			{
				this.TailDecorator.Size = value;
			}
		}

		[Category("LineCap")]
		public FillStyle StartCapFillStyle
		{
			get
			{
				if(this.TailDecorator != null)
					return this.TailDecorator.FillStyle;
				else 
					return null;
			}
		}

		[Category("LineCap")]
		public FillStyle EndCapFillStyle
		{
			get
			{
				if(this.HeadDecorator != null)
					return this.HeadDecorator.FillStyle;
				else 
					return null;
			}
		}

		[Category("LineCap")]
		public LineStyle EndCapLineStyle
		{
			get
			{
				if(this.HeadDecorator != null)
					return this.HeadDecorator.LineStyle;
				else 
					return null;
			}
		}


	
		[Category("LineCap")]
		public LineStyle StartCapLineStyle
		{
			get
			{
				if(this.TailDecorator != null)
					return this.TailDecorator.LineStyle;
				else 
					return null;
			}
		}

		#endregion

		#region Overrides
        public override void OnPropertyChanged(string strPropertyContainerName, string strPropertyName)
        {
            base.OnPropertyChanged(strPropertyContainerName, strPropertyName);
            if (strPropertyName == "LineColor")
            {
                if (this.HeadDecorator != null)
                {
                    this.HeadDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
                    this.HeadDecorator.FillStyle.Color = this.LineStyle.LineColor;
                }
                if (this.TailDecorator != null)
                {
                    this.TailDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
                    this.TailDecorator.FillStyle.Color = this.LineStyle.LineColor;
                }
            }
        }
        //protected override void OnPropertyChanged(PropertyEventArgs evtArgs)
        //{
        //    base.OnPropertyChanged (evtArgs);
        //    if(evtArgs.PropertyName == "LineColor")
        //    {
        //        if(this.HeadDecorator != null)
        //        {
        //            this.HeadDecorator.LineStyle.LineColor = (Color)evtArgs.NewValue;
        //            this.HeadDecorator.FillStyle.Color = (Color)evtArgs.NewValue;
        //        }
        //        if(this.TailDecorator != null)
        //        {
        //            this.TailDecorator.LineStyle.LineColor = (Color) evtArgs.NewValue;
        //            this.TailDecorator.FillStyle.Color = (Color)evtArgs.NewValue;
        //        }
        //    }
			
        //}

		#endregion
	}
}
