using System;
//using System.Collections;
//using System.Collections.Generic;
using Syncfusion.Windows.Forms.Diagram;


using Syncfusion.Windows.Forms.Diagram.Controls;
//using Syncfusion.Diagram.Base;
using System.Drawing;
using System.Runtime.Serialization;
using System.Drawing.Drawing2D;
using System.ComponentModel;
using PerpetuumSoft.Framework.Model;


namespace Symcon.Lightridge.LRRUI.Controls.Tools
{
	///	<summary>
	///	Vertical Link 
	///	</summary>
	[Serializable()]
	public class VerticalLink :	PolyLineConnector
	{


        //private EndPointDecorator _endPointDecorator  = new EndPointDecorator(EndPointVisuals.ClosedArrow);
        //private EndPointDecorator _startPointDecorator  = new EndPointDecorator(EndPointVisuals.ClosedArrow);
        private Syncfusion.Windows.Forms.Diagram.PolyLineConnector _line;


        public VerticalLink(PointF[] pts)
            : base(pts)
        {
        }
		
		/// <summary>
		/// Copy constructor.
		/// </summary>
		/// <param name="src"></param>
        public VerticalLink(VerticalLink src)
            : base(src)
        {

        }
		
		/// <summary>
		/// Serialization constructor for the MySymbol class.
		/// </summary>
		/// <param name="info">Serialization state information</param>
		/// <param name="context">Streaming context information</param>
        protected VerticalLink(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
            // The Serialization constructor is invoked during deserialization or during a drag & drop operation.
            // If the MySymbol type has serializable members, then initialize them with the serialized data 
            // obtained from the SerializationInfo param
        }

		#region Fields
		private PointF ptStartPoint; 
		private PointF ptEndPoint;

		#endregion

		#region Private Methods

		#endregion

		#region Public Methods



		 
		#endregion

		#region Properties

        //[Category("LineCap"),Editor(typeof(Syncfusion.Windows.Forms.Diagram.EndPointDecoratorEditor),typeof(System.Drawing.Design.UITypeEditor)),TypeConverter(typeof(EndPointDecoratorConverter))]
        //public EndPointDecorator EndCap
        //{
        //    get
        //    {
        //        return this.HeadDecorator;
        //    }
        //    set
        //    {
        //        this.HeadDecorator = value;
        //        if(this.HeadDecorator != null)
        //        {
        //            //this.HeadDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
        //            this.HeadDecorator.FillStyle.Color = this.LineStyle.LineColor;
        //        }
        //    }
        //}


        //[Category("LineCap"), Editor(typeof(Syncfusion.Windows.Forms.Diagram.EndPointDecoratorEditor),typeof(System.Drawing.Design.UITypeEditor)),TypeConverter(typeof(EndPointDecoratorConverter))]
        //public EndPointDecorator StartCap
        //{
        //    get
        //    {
        //        return this.TailDecorator;
        //    }
        //    set
        //    {
        //        this._line.FirstEndPointDecorator = value;
        //        if(this.TailDecorator != null)
        //        {
        //            //this.HeadDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
        //            this.TailDecorator.FillStyle.Color = this.LineStyle.LineColor;
        //        }
        //    }
        //}


		[Category("LineCap"),TypeConverter(typeof(SizeConverter))]
		public Size EndCapSize
		{
			get
			{
				if(this.HeadDecorator != null)
					return this.HeadDecorator.Size.ToSize();
				else 
					return new Size(0,0);

			}
			set
			{
				this.HeadDecorator.Size = value;
			}
		}


		[Category("LineCap"),DefaultValue(typeof(Size),null),TypeConverter(typeof(SizeConverter))]
		public Size StartCapSize
		{
			get
			{
				if(this.TailDecorator != null)
					return this.TailDecorator.Size.ToSize();
				else 
					return new Size(0,0);
			}
			set
			{
				this.TailDecorator.Size = value;
			}
		}

		[Category("LineCap")]
		public FillStyle StartCapFillStyle
		{
			get
			{
				if(this.TailDecorator != null)
					return this.TailDecorator.FillStyle;
				else 
					return null;
			}
		}

		[Category("LineCap")]
		public FillStyle EndCapFillStyle
		{
			get
			{
				if(this.HeadDecorator != null)
					return this.HeadDecorator.FillStyle;
				else 
					return null;
			}
		}

		[Category("LineCap")]
		public LineStyle EndCapLineStyle
		{
			get
			{
				if(this.HeadDecorator != null)
					return this.HeadDecorator.LineStyle;
				else 
					return null;
			}
		}


	
		[Category("LineCap")]
		public LineStyle StartCapLineStyle
		{
			get
			{
				if(this.TailDecorator != null)
					return this.TailDecorator.LineStyle;
				else 
					return null;
			}
		}

		#endregion

		#region  Overrides

		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>Copy of the object this method is invoked against</returns>
		public override object Clone()
		{
			return new VerticalLink(this);
		}


		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}

        public override void OnVertexChanged(VertexChangeType changeType, int nVertexIdx, PointF ptLocation)
        {
            ptStartPoint = this.TailEndPoint.Location;
            ptEndPoint = this.HeadEndPoint.Location;
            if (ptEndPoint.X != ptStartPoint.X)
            {
                PointF pt;
                if (this.PathPoints.Length < 3)
                {
                    pt = new PointF(ptEndPoint.X, ptStartPoint.Y);
                    this.InsertPoint(1, pt);
                }
                else
                {
                    pt = new PointF(ptEndPoint.X, ptStartPoint.Y);
                    this.SetPoint(1, pt);
                }
            }
            base.OnVertexChanged(changeType, nVertexIdx, ptLocation);
        }

        //protected override void OnMoveVertex(VertexChangedEventArgs evtArgs)
        //{
        //    ptStartPoint =  this.EndPoints.GetEndPointLocation(LineEndPoint.First);
        //    ptEndPoint = this.EndPoints.GetEndPointLocation(LineEndPoint.Last );
        //    if(ptEndPoint.X != ptStartPoint.X )
        //    {
        //        PointF pt;
        //        if(this.Points.PointCount <3)
        //        {
        //            pt = new PointF(ptEndPoint.X,ptStartPoint.Y);
        //            this.Points.InsertPoint(1,pt);
        //        }
        //        else
        //        {
        //            pt = new PointF(ptEndPoint.X,ptStartPoint.Y);
        //            this.Points.SetPoint(1,pt);

        //        }


        //    }
        //    base.OnMoveVertex (evtArgs);
        //}


        /* CreateLinkShape method is no longer available. We suggest you to use the 
         * CreateLogicalGraphicsPath instead of that method*/
        protected override GraphicsPath CreateLogicalGraphicsPath(PointF[] pts)
        {
            return base.CreateLogicalGraphicsPath(pts);
        }

//        protected override IPoints  CreateLinkShape(Syncfusion.Windows.Forms.Diagram.Link shapeType, System.Drawing.PointF[] pts)
//        {
//            Shape linkShape	= null;
//            try
//            {
				
//                _line =	new	PolyLine();
				
//                linkShape =	_line;
//                if(linkShape !=	null)
//                {
//                    if(pts[0].X != pts[1].X)
//                    {
//                        PointF pt = new PointF(pts[1].X,pts[0].Y);
//                        PointF endPoint = pts[1];
//                        pts[1] = pt;
//                        pts[2] = endPoint;
//                    }

//                    linkShape.SetPoints(pts);
//                }

////				this.HeadDecorator = _endPointDecorator;
////				this.TailDecorator = _startPointDecorator;
//            }
//            catch(Exception ex)
//            {
//                string msg = ex.Message;
//            }
//            return linkShape;
//        }

       
        //protected override void OnConnectionsChangeComplete(CollectionExEventArgs evtArgs)
        //{
        //    base.OnConnectionsChangeComplete (evtArgs);
        //    if(evtArgs.ChangeType == CollectionExChangeType.Insert)
        //    {
        //        //if (evtArgs.Connection.SourcePort.GetType().Name =="CirclePort")
        //        //{
        //        //    if(evtArgs.Connection.SourcePort.Parent.GetType().BaseType == typeof(Symbol))
        //        //    {
        //        //        Symbol smbl	= evtArgs.Connection.SourcePort.Parent as Symbol;
        //        //    }
        //        //}

        //        if (evtArgs.Connection.TargetPort.GetType().Name=="CirclePort")
        //        {
        //            if(evtArgs.Connection.TargetPort.Parent.GetType().BaseType == typeof(Symbol))
        //            {
        //                //Symbol smbl	= evtArgs.Connection.TargetPort.Parent as Symbol;
        //                ptStartPoint =  this.TailEndPoint.Location;
        //                ptEndPoint = this.HeadEndPoint.Location;
        //                if(ptEndPoint.X != ptStartPoint.X )
        //                {
        //                    PointF pt;
        //                    if(this.PathPoints.Length <3)
        //                    {
        //                        pt = new PointF(ptEndPoint.X,ptStartPoint.Y);
        //                        this.InsertPoint(1,pt);
        //                    }
        //                    else
        //                    {
        //                        pt = new PointF(ptEndPoint.X,ptStartPoint.Y);
        //                        this.SetPoint(1,pt);

        //                    }
        //                }
        //            }
        //        }
        //    }
        //}

        public override void OnPropertyChanged(string strPropertyContainerName, string strPropertyName)
        {
            base.OnPropertyChanged(strPropertyContainerName, strPropertyName);
            if (strPropertyName == "LineColor")
            {
                if (this.HeadDecorator != null)
                {
                    this.HeadDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
                    this.HeadDecorator.FillStyle.Color = this.LineStyle.LineColor;
                }
                if (this.TailDecorator != null)
                {
                    this.TailDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
                    this.TailDecorator.FillStyle.Color = this.LineStyle.LineColor;
                }
            }
         }

        //protected override void OnPropertyChanged(PropertyEventArgs evtArgs)
        //{
        //    base.OnPropertyChanged (evtArgs);
        //    if(evtArgs.PropertyName == "LineColor")
        //    {
        //        if(this.HeadDecorator != null)
        //        {
        //            this.HeadDecorator.LineStyle.LineColor = (Color)evtArgs.NewValue;
        //            this.HeadDecorator.FillStyle.Color = (Color)evtArgs.NewValue;
        //        }
        //        if(this.TailDecorator != null)
        //        {
        //            this.TailDecorator.LineStyle.LineColor = (Color) evtArgs.NewValue;
        //            this.TailDecorator.FillStyle.Color = (Color)evtArgs.NewValue;
        //        }
        //    }		
        //}
		#endregion
	}
}
